if(!dojo._hasResource["com.ibm.mm.builder.SkinHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.SkinHelper"] = true;
dojo.provide("com.ibm.mm.builder.SkinHelper");

dojo.require("com.ibm.mm.builder.widget.WidgetMenu");
dojo.require("com.ibm.mm.builder.constant");

dojo.declare("com.ibm.mm.builder.SkinHelper", null, {

    overWidgetHandler: null,
    outWidgetHandler: null,
	
	nva_IconHideTimer:null,
	nva_IconShowTimer:null,
    
    // create a menu
    createMenu: function(evt, targetNodeId, widgetId, inNva){
		//fix for defect 12032: if user click on the widget menu icon while one context menu is showing
		if (com.ibm.mm.builder.widgetMenu && com.ibm.mm.builder.widgetMenu.pMenu && com.ibm.mm.builder.widgetMenu.pMenu.isShowingNow){
			if (widgetId != com.ibm.mm.builder.widgetMenu.iwidgetId){
				//if the showing menu is from another widget
				com.ibm.mm.builder.widgetMenu.hideMenu();
			}else{
				//if the showing menu is the menu user want to open again
				return;
			}
		}
		if(com.ibm.mm.builder.widgetMenu){
			com.ibm.mm.builder.widgetMenu.destroy();
		}
		// end fix for 12032
        com.ibm.mm.builder.widgetMenu = new com.ibm.mm.builder.widget.WidgetMenu({
			iwidgetId: widgetId,
			inNva: inNva,
			targetNode: dojo.byId(targetNodeId)
		});
		com.ibm.mm.builder.widgetMenu.open(evt);
        com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
    },
    
    // launch wiring UI
    launchWiring: function(widgetId){
		var widgetUtil = com.ibm.mm.builder.utils.iwidgetUtil;
		var widgetIcon =widgetUtil.getWidgetInstanceIcon(widgetId);
		var dialogParam = {
			nodeWidth: "486px",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_WIRING_NAME,
			titleIconUrl: widgetIcon,
			leftBarWidth: "18px",
			rightBarWidth: "12px",
			displayCloseButton: true,
			hasRightBottomResizer: false
		};
		var payload = {
	    	widgetTypeId: "wireInterface",
	        eventName:  "com.ibm.mashups.builder.editWire",
	        eventPayload:  widgetId,
	        dialogParam:  dialogParam,
			hasRightBottomResizer: false,
	        requestRefresh: true
		};
		com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
    },
    
    getMaxZOrder: function(layoutId){
		var maxZOrder = 50;
		// TODO: we need enabler api to query out the inner widgets in a layout widget
		//Temp fix because the loadWidgets is called twice due to the temp fix of defect 7971,make sure the iContext is not null
		// TODO: we need to find out why it's called twice
		if (eval("_" + layoutId + "_iContext")) { // JSLINT-IGNORE:
			var widgetIds = eval("_" + layoutId + "_iContext.scope.getWidgets()"); // JSLINT-IGNORE:
			if (widgetIds && widgetIds.length > 0) {
				for (var i = 0; i < widgetIds.length; i++) {
					var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + widgetIds[i]);
					if (skinDiv && skinDiv.style.zIndex) {
						var indexInt = parseInt(skinDiv.style.zIndex,10);
						if (maxZOrder < indexInt) {
							maxZOrder = indexInt;
						}
					}
				}
				// make sure the zIndex value is the biggest one.
				maxZOrder = maxZOrder + 1;
			}
		}
        return maxZOrder;
    },
    
    // Display Menu Icons in NVA skin
    displayMenuIcon: function(menuId, iconId, nameId, upperId){
        // these two timers are needed to dealing with IE7
        window.clearTimeout(this.nva_IconHideTimer);
        this.nva_IconShowTimer = window.setTimeout(function(){
            if (dijit.byId(menuId + "_menu")) {
				return;
			}
			var menu = dojo.byId(menuId);
            var icon = dojo.byId(iconId);
            menu.style.display = "";
            icon.parentNode.style.display = "none";
            
            // change skin layout
			var upper = dojo.byId(upperId);
			
			dojo.addClass(upper, "nvaUpperDivHovered");

			//for a11y
			var wiringIcon = dojo.query(".nva_widgetInteraction", menu)[0];
			wiringIcon.focus();
        }, 10);
        
    },
    
    // Hide Menu Icons in NVA skin
    hideMenuIcon: function(menuId, iconId, nameId, upperId){
        // these two timers are needed to dealing with IE7
        window.clearTimeout(this.nva_IconShowTimer);
		if (dijit.byId(menuId + "_menu")) {
			return;
		}
        this.nva_IconHideTimer = window.setTimeout(function(){
			if (dijit.byId(menuId + "_menu")) {
				return;
			}
			com.ibm.mm.builder.skinHelper.hideNVASkinEditMode(menuId, iconId, nameId, upperId);
        }, 10);
    	
    },
	
	hideNVASkinEditMode:function(menuId, iconId, nameId, upperId){
        var menu = dojo.byId(menuId);
        if (menu) {
			menu.style.display = "none";
		}

	    var icon = dojo.byId(iconId);
        if (icon) {
			icon.parentNode.style.display = "";
		}
        
        // change skin layout
        var upper = dojo.byId(upperId);
		
		if (upper) {
			dojo.removeClass(upper, "nvaUpperDivHovered");
		}
	},
    
    // Display edit bar
    displayEditBar: function(editBarId,resizeBarId){
        this.setEditBarOpaque(editBarId,resizeBarId);
    },
    
    // Hide edit bar
    hideEditBar: function(editBarId,resizeBarId){
    	window.clearTimeout(this["showEditTimer_" + editBarId]);
        window.clearTimeout(this["hideEditTimer_" + editBarId]);
       	var tid = "";
    	if (builderConfig.isBidi && dojo.isIE === 6) {
			tid = this.getWidgetIdByEditBarId(editBarId);
		}
        this["hideEditTimer_" + editBarId] = window.setTimeout(function(){
			var resizeId = editBarId.replace(com.ibm.mm.builder.constant.dragHandler+"_editbar",com.ibm.mm.builder.constant.resizeHandlerExt);
            var resizeBar;
            if (resizeBarId) {
				resizeBar = dojo.byId(resizeBarId);
			} else {
				resizeBar = dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler + "_editbar", com.ibm.mm.builder.constant.resizeHandlerExt)) || dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler + "_editbar", com.ibm.mm.builder.constant.resizeHeightExt));
			}
            var editBar = dojo.byId(editBarId);
            if (editBar) {
                editBar.style.display = "none";
                if (builderConfig.isBidi && dojo.isIE) {                	
			    	dojo.removeClass(dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody),"widgetBodyEdit");
			    	var _title = dojo.byId(tid+"_title");
			    	if (_title) {
						dojo.removeClass(dojo.byId(tid + "_title"), "widgetTitleEdit");
					}
			    	if (dojo.hasClass(dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent),"rtlOverride_IE_paddingTop_0px")) {
			    		dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent).style.paddingTop = "0px";
			    	}			    	
                }
            }
            if(resizeBar){
            	resizeBar.style.display = "none";
            }
        }, 100);
    },
	
	// IE6 only: keep the editBar when mouse is moving on the widgetBody's margin
	keepEditBar: function(editBarId) {
		window.clearTimeout(this["hideEditTimer_" + editBarId]);
	},
    
    // Set edit bar opaque
    setEditBarOpaque: function(editBarId,resizeBarId){
    	window.clearTimeout(this["hideEditTimer_" + editBarId]);
    	if (!(builderConfig.isBidi && dojo.isIE===6)) {
	        this.showEditBarTimer = window.setTimeout(function(){
	        	var resizeBar;
	            if (resizeBarId) {
					resizeBar = dojo.byId(resizeBarId);
				} else {
					resizeBar = dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler + "_editbar", com.ibm.mm.builder.constant.resizeHandlerExt)) || dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler + "_editbar", com.ibm.mm.builder.constant.resizeHeightExt));
				}
	            var editBar = dojo.byId(editBarId);
				if (editBar){
	                editBar.style.display = "";
	            }
	            if(resizeBar){
	            	resizeBar.style.display = "";
	            }
	        }, 100);
    	} else {
    		this.bidiSetEditBarOpaque(editBarId,resizeBarId);
    	}
    },
    
    getEditBarIdBySkinId: function(skinId){
        var widgetId = skinId.substring(com.ibm.mm.builder.constant.skinIdPrefix.length, skinId.length);
        return widgetId + com.ibm.mm.builder.constant.editbarDragHandler;
    },
    getColumnResizeBarIdBySkinId: function(skinId){
        var widgetId = skinId.substring(com.ibm.mm.builder.constant.skinIdPrefix.length, skinId.length);
        return widgetId + com.ibm.mm.builder.constant.resizeHeightExt;
    },
    getFreeFormResizeBarIdBySkinId: function(skinId){
        var widgetId = skinId.substring(com.ibm.mm.builder.constant.skinIdPrefix.length, skinId.length);
        return widgetId + com.ibm.mm.builder.constant.resizeHandlerExt;
    },
    getWidgetIdByEditBarId: function(editBarId){
        return editBarId.substr(0, editBarId.length - com.ibm.mm.builder.constant.editbarDragHandler.length);
    },
    getWidgetIdByNvaSkinId: function(skinId){
        skinId = skinId.replace(com.ibm.mm.builder.constant.skinIdPrefix, "");
        return skinId.replace(com.ibm.mm.builder.constant.nva_skin_upper, "");
    },
    /*
	 * Use bidiSetEditBarOpaque to fix the display in rtl IE6 when hovering
	 * over the widget and displaying the edit bar.  In the rtl IE6 browser,
	 * the parent div of the editBar gets height and makes the widget much
	 * taller than it is supposed to be.  Same thing may happen on the resizer
	 * div.
	 * 
	 * Note:  This problem exists only on the rtl IE6 browser, and in both 
	 * freestyle and column layouts.
     */
	 bidiSetEditBarOpaque: function(editBarId,resizeBarId) {
	    if (builderConfig.isBidi && dojo.isIE === 6) {
	    	var bodyTop = null;
	    	var titleTop = null;
	    	var contentPaddingTop = null;
	    	var tid = this.getWidgetIdByEditBarId(editBarId); 
	    	if (this.isColumnLayout(tid)) {
				dojo.byId(tid + com.ibm.mm.builder.constant.editbarDragHandler).style.position = "static";
			}
	    	var style = this.getStyle(dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody),"top");
	    	if (style !== null) {	    			
    			bodyTop = style;
    	    	var adjust = this.getColumnLayoutAdjustment(tid);
    			if (adjust) {
					bodyTop = parseInt(bodyTop,10) + adjust + "px";
				}	
	    	}
	    	var _title = dojo.byId(tid+"_title");
	    	if (_title) {
	    		style = this.getStyle(_title,"top");
	    		if (style !== null) {
					titleTop = style;
				}
	    	}
	    	contentPaddingTop = this.getStyle(dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent),"paddingTop");
		    this.showEditBarTimer = window.setTimeout(function(){
		    	var resizeBar;
		        if (resizeBarId) {
					resizeBar = dojo.byId(resizeBarId);
				} else {
					resizeBar = dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler + "_editbar", com.ibm.mm.builder.constant.resizeHandlerExt)) || dojo.byId(editBarId.replace(com.ibm.mm.builder.constant.dragHandler + "_editbar", com.ibm.mm.builder.constant.resizeHeightExt));
				}
		        var editBar = dojo.byId(editBarId);
				if (editBar){
		            editBar.style.display = "";
			    	dojo.addClass(dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody),"widgetBodyEdit");
			    	var _title = dojo.byId(tid+"_title");
			    	if (_title) {
						dojo.addClass(dojo.byId(tid + "_title"), "widgetTitleEdit");
					}
	        		if (bodyTop !== null) {
						dojo.byId(tid + com.ibm.mm.builder.constant.widgetBody).style.top = bodyTop;
					}
	            	if (titleTop !== null) { 
						_title.style.top = titleTop;
					}
	            	if (contentPaddingTop !== null) {
						dojo.byId(tid + com.ibm.mm.builder.constant.widgetContent).style.paddingTop = contentPaddingTop;
					}
		        }
		        if(resizeBar){
		        	resizeBar.style.display = "";
		        }
		    }, 100);
	    }	
	},
	/* getStyle is used to get a position for rtl IE edit mode.
	 * Currently, the following class name patterns are supported:
	 *    rtlEditIE6_<value>,rtlEditIE7_<value>, rtlEditIE8_<value>  
	 * 
	 * In the skin.html's body or title div (any div can be passed in),
	 * a class should be added following this naming convention if the
	 * widget requires repositioning.
	 * An example is the Glass/Tinted Glass theme which uses 
	 *    rtlEditIE6_top_50px
	 *    
	*/
	getStyle: function(div,search) {
		var className = (div.className).split(" ");
		if (className) {
			for (var i=0; i<className.length; i++) {
				var str = className[i].split("_");
				if (str.length && str.length === 3) {
					if ( (str[0] == "rtlEditIE6" && dojo.isIE===6) ||
						 (str[0] == "rtlEditIE7" && dojo.isIE===7) ||
						 (str[0] == "rtlEditIE8" && dojo.isIE===8) ) {
						if (str[1] === search) {
						   return str[2];
						}
					}
				}
			}
		}
	    return null;
	},
	
	getColumnLayoutAdjustment: function(tid) {
		var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + tid);
		var adjust = 0;
		var pageAttrJson = null;
		var sibling = skinDiv.previousSibling;
		while (sibling) {
			//in columnLayout, add up the skin heights plus widthbetweenWidgets for widgets above this one			
			if (pageAttrJson === null) {
				pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
			}
			adjust = adjust + parseInt(sibling.style.height,10)+parseInt(pageAttrJson.widthBetweenWidgets,10);
			sibling = sibling.previousSibling;
		}
		return adjust;
	},
	
	isColumnLayout: function(tid) {
		var skinDiv = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + tid);
		var isColumnLayout = false;
		var parent = skinDiv.parentNode;
		if (dojo.hasClass(parent, com.ibm.mm.builder.constant.columnLayoutClass)) {
			isColumnLayout = true; 
		}
		return isColumnLayout;
	}	
});

// global variable of Constant
com.ibm.mm.builder.skinHelper = new com.ibm.mm.builder.SkinHelper();
com.ibm.mm.builder.widgetMenu = null;

}
