if(!dojo._hasResource["com.ibm.mm.builder.dnd.FreeformSource"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.dnd.FreeformSource"] = true;
/**
 * @author Jarod(zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.dnd.FreeformSource");

/**
 * FreeformSource is the drop target of one column in free form
 */
dojo.declare("com.ibm.mm.builder.dnd.FreeformSource", dojo.dnd.AutoSource, {
	
	accept: ["iWidgetDefinition", "iWidgetInstance"],
	withHandles: true,
	
	constructor: function(node, params){
		dojo.subscribe("/dnd/cancel", this, "onDndDragOut");
		this.logger = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.dnd.FreeformSource");
	},
	
	onDropExternal: function(source, nodes, copy){
		try {
			var draggedNodeId = nodes[0].id;
			var item = source.getItem(draggedNodeId);
			var type = item && item.type && item.type[0];
			var constraints = dojo.coords(this.node, true);
			var _position = {
				x: Math.max(this._last_drop_X - constraints.x, 0),
				y: Math.max(this._last_drop_Y - constraints.y, 0)
			};

			if(type === "iWidgetDefinition"){
				var defaultWidgetWidth = com.ibm.mm.builder.constant.defaultWidgetWidth;
				if (constraints.w - _position.x < defaultWidgetWidth) {
					_position.x = constraints.w - defaultWidgetWidth;
				}
				this.layout.createWidget(item.data, {position: _position});
			}else{
				this.layout.displayWidget({id: item.data, position: _position});
			}
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		} catch (e) {
			this.logger.severe("onDropExternal", e.message);
		}
	},
	
	onDropInternal: function(nodes, copy){
		try {
			this.inherited(arguments);
			this._moveDraggedNode(this.getSelectedNodes()[0]);
		} catch (e) {
			this.logger.severe("onDropInternal", e.message);
		}
	},
	
	onDndDragOut: function(){
		try {
			if (dojo.dnd.manager().source !== this) { return; }
			
			var draggedWidgetSkin = this.getSelectedNodes()[0];
			var draggedWidgetSpan = dojo.query(".mm_iWidget", draggedWidgetSkin)[0];
			
			this.layout.focusWidget(draggedWidgetSpan.id);
			this._moveDraggedNode(draggedWidgetSkin);
			
			com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		} catch (e) {
			this.logger.severe("onDndDragOut", e.message);
		}


	},
	
	onMouseMove: function(e){
		try {
			com.ibm.mm.builder.dnd.FreeformSource.superclass.onMouseMove.call(this, e);
			if (this.isDragging) {
				var m = dojo.dnd.manager();
				if (this === m.source && m.avatar && m.avatar.node && m.avatar.node.style.marginLeft === "0px" && (dojo.isOpera || e.layerX > 0)) {
					var ml = builderConfig.isBidi ? (parseInt(this.getSelectedNodes()[0].style.width, 10) - this._last_layerX) : this._last_layerX;
					dojo.style(m.avatar.node, {
						'marginLeft': -ml + "px",
						'marginTop': 34 - this._last_layerY + "px"
					});
					dojo.query(".dojoDndItem", m.avatar.node).style({
						display: ""
					});
				}
			}
		} catch (err) {
			this.logger.severe("onMouseMove", err.message);
		}
	},
	
	onMouseUp: function(e){
		try {
			this._last_drop_X = e.pageX;
			this._last_drop_Y = e.pageY;
			com.ibm.mm.builder.dnd.FreeformSource.superclass.onMouseUp.call(this, e);
		} catch (err) {
			this.logger.severe("onMouseUp", err.message);
		}
	},
	
	onMouseDown: function(e){
		com.ibm.mm.builder.dnd.FreeformSource.superclass.onMouseDown.call(this, e);
		this._last_layerX =  dojo.isOpera ? e.offsetX: e.layerX;
		this._last_layerY =  dojo.isOpera ? e.offsetY: e.layerY;
	},
	
	onDndCancel: function(){
		try {
			if( this === dojo.dnd.manager().source ){ com.ibm.mm.builder.utils.htmlUtil.showNodes(dojo.dnd.manager().nodes); }
				this.inherited(arguments);
		} catch (e) {
			this.logger.severe("onDndCancel", e.message);
		}
	},
	
	onDndStart: function(source, nodes, copy){
		try {
			if(this === source){ com.ibm.mm.builder.utils.htmlUtil.hideNodes(nodes); }
				this.inherited(arguments);
		} catch (e) {
			this.logger.severe("onDndStart", e.message);
		}
	},
	
	/*
	 * move dragged node to avatar's position
	 */
	_moveDraggedNode: function(widgetNode){
		try {
			var m = dojo.dnd.manager();
				var cst = dojo.coords(this.node);
				var ac = dojo.coords(m.avatar.node);
				dojo.marginBox(widgetNode, {l:ac.x  - cst.x, t: ac.y  - cst.y});
				com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		} catch (e) {
			this.logger.severe("_moveDraggedNode", e.message);
		}
	},
	
	moving: function(e){
		try {
			var m = dojo.dnd.manager();
			var avatar = m.avatar;
			if(!avatar){
				return false;
			}
			dojo.dnd.autoScroll(e);
			
			var a = dojo.coords(avatar.node);
			var ml = parseInt(avatar.node.style.marginLeft, 10) || 0;
			var mt = parseInt(avatar.node.style.marginTop, 10) || 0;
			//avatar container coords
			var ac = {
				l: (e.pageX + m.OFFSET_X),
				t: (e.pageY + m.OFFSET_Y),
				w: a.w - ml,
				h: a.h
			};
			
			var cst = dojo.coords(this.node, true);
			//source constrained area
			var c = {
				l:cst.x + 1 - ml,
				r:cst.x + cst.w - ml - ac.w, 
				t:cst.y - mt,
				b:cst.y + cst.h - ac.h
			};
			//limit four direction.
			//avatar.node.style.left = (ac.l < c.l ? c.l : c.r < ac.l ? c.r : ac.l) + "px";
			//avatar.node.style.top = (ac.t < c.t ? c.t : c.b < ac.t ? c.b : ac.t) + "px";
			//limit only top-left direction.
			var al = ac.l < c.l ? c.l : ac.l;
			var at = ac.t < c.t ? c.t : ac.t;
			dojo.marginBox(avatar.node, {l: al, t: at});
			//adjust the width
			com.ibm.mm.builder.utils.pageWidthChanger.widgetToBeMoved(null, ac.l, ac.w);
			//adjust the height
			if (e.pageY > c.b) {
			   var newHeight = (e.pageY + ac.h);
			   dojo.style(this.node, "height", newHeight + "px");
			   //Also change the freeform div height to fix defect 8342
			   dojo.byId(this.layout.iContext.widgetId).style.height = newHeight+"px";
			}
		} catch (err) {
			this.logger.severe("moving", err.message);
		}
	}
});

}
