if(!dojo._hasResource["com.ibm.mm.builder.iwidget.SpaceSelector"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.SpaceSelector"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.SpaceSelector");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.mm.builder.widget.ShadowMenu");
dojo.require("com.ibm.mm.builder.iwidget.navigation.NavigationPanel");

(function(){
var maxLen = 150;
var utils = com.ibm.mm.builder.utils;
var htmlUtil = utils.htmlUtil;
var pageUtil = utils.pageUtil;
var navigationUtil = utils.navigationUtil;
var themeUtil = utils.themeUtil;
var spaceUtil = utils.spaceUtil;
var acModelUtil = utils.acModelUtil;
var userUtil = utils.userUtil;
var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
var cws = com.ibm.mm.builder.coreWidgetsStrings;
var spaceSelector = null;

dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelector",
	[dijit._Widget, dijit._Templated],{
	
	templateString: 
		'<div class="spaceSelector">'+
			'<div dojoAttachPoint="containerNode" class="spaceSelectorTitle" tabindex=0 aria-haspopup="true" role="button"'+
				'dojoAttachEvent="onmouseover:_onHover,onmouseout:_onUnHover,onkeypress:_onSelectorKeyPress,onfocus:_onFocus, onblur:_onBlur"></div>'+
			'<div class="spaceSelectorAction middleImageDiv" dojoAttachPoint="spaceSelectorAction">' + 
				'<a class="spaceSelectorImageContainer" href="#" role="button" wairole="button" dojoAttachEvent="onkeypress:_onSpaceMenuKeyPress,onclick:_openSpaceMenu" dojoAttachPoint="spaceSelectorImgContainer" style="display:none;" >' +
				'<img class="spaceSelectorImage" border="0" title="" '+
					'dojoAttachPoint="spaceSelectorImg" /></a>' +
			'</div>'+
		'</div>',
	
	postCreate: function(){
		spaceSelector = this;
	},
	
	_createSpaceSelectorMenu: function(){
		this.spaceSelectorMenu = new com.ibm.mm.builder.iwidget.SpaceSelectorMenu({ targetNodeIds: [this.containerNode] });
	},
	
	_createSpaceActionMenu: function(){
		
		
		dojo.attr(this.spaceSelectorImg, 'alt', cws.I_SPACE_SELECTOR_ACTION_MENU_BUTTON );
		dojo.attr(this.spaceSelectorImgContainer, 'title', cws.I_SPACE_SELECTOR_ACTION_MENU_BUTTON );
		var title=null;
		if (spaceUtil.isPersonalSpace() || userUtil.isLockedDownAnonymousMode()) {
			
			dojo.addClass(this.spaceSelectorAction, "spaceSelectorActionDisabled");
			this.spaceSelectorAction.setAttribute("disabled", true);
		     title = cws.I_SPACE_SELECTOR_IN_PERSONAL_SPACE ;
			dojo.attr(this.spaceSelectorImg,'title',title);
			dojo.attr(this.spaceSelectorImg,'aria-label',title);
			
		}
		else {
			dojo.removeClass(this.spaceSelectorAction, "spaceSelectorActionDisabled");
			this.spaceSelectorAction.removeAttribute("disabled");
		     title = cws.I_SPACE_SELECTOR_OPEN_ACTION_MENU;
			dojo.attr(this.spaceSelectorImg,'title',title);
			dojo.attr(this.spaceSelectorImg,'aria-label',title);			
			
			this.spaceActionMenu = new com.ibm.mm.builder.iwidget.SpaceActionMenu({
				targetNodeIds: [this.spaceSelectorImg]
			});
		}
		this.spaceSelectorImg.src = builderConfig.builderPath + "/images/pageaction/down_triangle_white.png";
		this.spaceSelectorImgContainer.style.display = "";
		this._adjustWidthForBidiIE();
	},
	
	refresh: function(spaceId){
		this.uninitialize();
		var limitedTitle = htmlUtil.getStrWithLimit(spaceUtil.getSpaceTitle(spaceId), this.containerNode, 153);
		this.containerNode.innerHTML = limitedTitle;
		if (builderConfig.isBidi&& (dojo.isIE === 6 || dojo.isIE === 8)) {
			var w = htmlUtil.getStrWidth(limitedTitle, this.containerNode);
			this.containerNode.style.width = w + "px";
		}
		this._createSpaceSelectorMenu();
		this._createSpaceActionMenu();
	},
	
	_onHover: function(evt){
		dojo.addClass(this.containerNode, "spaceSelectorTitleHover");
	},
	
	_onUnHover: function(evt){
		if(!this.spaceSelectorMenu || !this.spaceSelectorMenu.isShowingNow){
			dojo.removeClass(this.containerNode, "spaceSelectorTitleHover");
		}
	},
	
	_onFocus:function(){
		dojo.addClass(this.containerNode, "spaceSelectorTitleHover");
		dijit.focus(this.containerNode);
	},
	
	_onBlur:function(){
		if(!this.spaceSelectorMenu || !this.spaceSelectorMenu.isShowingNow){
			dojo.removeClass(this.containerNode, "spaceSelectorTitleHover");
		}
	},
	
	_onSelectorKeyPress: function(evt){
		switch(evt.keyCode || evt.charCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
				this.spaceSelectorMenu._openMyself(evt);
			break;
		}
	},
	_openSpaceMenu: function(evt) {
		if (this.spaceActionMenu) {
			this.spaceActionMenu._openMyself(evt);
		}
	},
	_onSpaceMenuKeyPress: function(evt){
		if (spaceUtil.isPersonalSpace()) {
			return;
		}
		switch(evt.keyCode || evt.charCode){
			case dojo.keys.UP_ARROW:
			case dojo.keys.DOWN_ARROW:
			case dojo.keys.ENTER:
			case dojo.keys.SPACE:
				if (this.spaceActionMenu) {
					this.spaceActionMenu._openMyself(evt);
				}
			break;
		}
	},
	
	uninitialize: function(){
		if (this.spaceSelectorMenu) {
			if(this.spaceSelectorMenu.isShowingNow){ dijit.popup.close(this.spaceSelectorMenu); }
			this.spaceSelectorMenu.destroyRecursive();
			this.spaceSelectorMenu = null;
		}
		if (this.spaceActionMenu) {
			if(this.spaceActionMenu.isShowingNow){ dijit.popup.close(this.spaceActionMenu); }
			this.spaceActionMenu.destroyRecursive();
			this.spaceActionMenu = null;
		}
	},
	
	_adjustWidthForBidiIE: function(){
		if (builderConfig.isBidi && (dojo.isIE)) {
			setTimeout(function(){
				var selector = dojo.query(".spaceSelectorDiv")[0];			
				var title = dojo.query(".spaceSelectorTitle")[0];
				var piw = dojo.coords(title, true).w;
				selector.style.width=piw+30+"px";
			}, 0);
		}
	}
	
});

dojo.declare("com.ibm.mm.builder.iwidget.SpaceSelectorMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	leftClickToOpen: true,
	
	postCreate: function(){
		dojo.addClass(this.domNode, "spaceSelectorMenu");
		if(!this.isLeftToRight()){ this.offset_x = -9;}
		this.inherited(arguments);
	},
	
	onClose: function(){
		spaceSelector.containerNode.blur();
		dojo.removeClass(spaceSelector.containerNode, "spaceSelectorTitleHover");
		this.inherited(arguments);
	},
	
	prepareData: function(){
		dojo.addClass(spaceSelector.containerNode, "spaceSelectorTitleHover");		
		if (!userUtil.isLockedDownAnonymousMode()) {
			this.addChild(new dijit.MenuItem({
				label: cws.I_SPACE_MANAGE_SPACES,
				postCreate: function(){
					dijit.MenuItem.prototype.postCreate.call(this);
					htmlUtil.markTruncation(this.containerNode, "153");
				},
				onClick: function(){
					var payload = {
						widgetTypeId: "spaceManager",
						eventName: "com.ibm.mashups.builder.showSpaceManager",
						eventPayload: "",
						dialogParam: {
							title: cws.I_SPACE_MANAGE_SPACES,
							nodeWidth: "910px",
							nodeHeight: "750px",
							containerBackgroundColor: "white",
							hasRightBottomResizer: false
						}
					};
					eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
				}
			}));
		}
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.spaceSelector", null, null, {
			context: this
		});
		for (var i = 0; i < widgetMenus.length; ++i) {
			var mitem = new dijit.MenuItem({
				label: spaceUtil.getPersonalSpaceTitle(),
				postCreate:function(){
					dijit.MenuItem.prototype.postCreate.call(this);
					htmlUtil.markTruncation(this.containerNode,"153");
				},// JSLINT-IGNORE:
				onClick: widgetMenus[i].actionCallBackFunction
			});
			this.addChild(mitem);
		}
		
		var spaceModel = spaceUtil.getSpaceModel();
		var spaceNodes = spaceModel;
		if (!userUtil.isLockedDownAnonymousMode()) {
			spaceNodes = spaceModel.findFavorites();
		}
		if(spaceNodes.hasNext()){
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
		}
		var self = this;
		while (spaceNodes.hasNext()) {
			(function(){
				var node = spaceNodes.next();
				if (spaceUtil.isVisiable(node)) {
					var nodeId = node.getID();
					var rootNodeId = spaceModel.find(nodeId).start().getRootNavigation().getID();
					var c = new (nodeId === spaceUtil.getHomeSpaceId() ? com.ibm.mm.builder.iwidget.HomeSpaceMenuItem : dijit.MenuItem)({ // JSLINT-IGNORE:
						label: com.ibm.mm.builder.utils.enablerUtil.getNodeTitle(node),
						postCreate: function(){
							if (this.declaredClass === "dijit.MenuItem") {
								dijit.MenuItem.prototype.postCreate.call(this);
								htmlUtil.markTruncation(this.containerNode,"153");
							} else {
								com.ibm.mm.builder.iwidget.HomeSpaceMenuItem.prototype.postCreate.call(this);
							}
						},
						_onClick: function(){
							dijit.popup.close(this.getParent());
							var callbackFun = dojo.hitch(this,function(){
								eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace",nodeId);
							});
							com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(callbackFun);
						},
						popup: new com.ibm.mm.builder.iwidget.navigation.NavigationMenu({
							parentPageId: rootNodeId,
							dndDisable: true
						})
					});
					dojo.attr(c.domNode, "space_id", nodeId);
					self.addChild(c);
				}
			})();   // JSLINT-IGNORE:
		}
		//todo confirmInsert
		if (!userUtil.isLockedDownAnonymousMode() && spaceUtil.getSpaceModel().confirmCreate()) {
			this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
			this.addChild(new dijit.MenuItem({
				label: cws.I_SPACE_CREATE_NEW_SPACE,
				postCreate:function(){
					dijit.MenuItem.prototype.postCreate.call(this);
					htmlUtil.markTruncation(this.containerNode,"153");
				},
				onClick: function(){
					var callbackFun = dojo.hitch(this,function(){
						var payload = {
							widgetTypeId: "createSpace",
							eventName: "com.ibm.mashups.builder.createSpace",
							eventPayload: {createSpaceFromSpaceManager:false},	
							dialogParam: {
								nodeWidth: "675px",
								title: cws.CREATE_SPACE_CAPTION,
								containerBackgroundColor: "white",
								hasRightBottomResizer: false
							}
						};
						eventService.broadcastEvent("com.ibm.mashups.builder.displayInMashupDialog", payload);
					});
					com.ibm.mm.builder.utils.pageUtil.savePageWithConfirm(callbackFun);
				}
			}));
		}
		htmlUtil.truncateAllChildNodesText(this.domNode,null,{fontSize:"1.2em"});
	},
	
	_onKeyPress: function(evt){
		if(evt.ctrlKey || evt.altKey){ return; }

		switch(evt.keyCode){
			case dojo.keys.RIGHT_ARROW:
				this.onItemHover(this.focusedChild);
				break;
			case dojo.keys.LEFT_ARROW:
				if(this.parentMenu){
					this.onCancel(false);
				}else{
					dojo.stopEvent(evt);
				}
				break;
		}
	},
	
	switchToPersonalSpace: function(){
		eventService.broadcastEvent("com.ibm.mashups.builder.switchSpace");
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.SpaceActionMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	offset_y: 3,
	
	leftClickToOpen:true,
	
	postCreate: function(){
		dojo.addClass(this.domNode, "spaceActionMenu");
		this.inherited(arguments);
	},
	
	prepareData: function(){
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var currentSpaceId = com.ibm.mm.builder.utils.spaceUtil.getCurrentSpaceId();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.spaceAction", currentSpaceId, null, {
			context: this
		});
		for (var i = 0; i < widgetMenus.length; ++i) {
			if (widgetMenus[i].isSeparator) {
				this.addChild(new com.ibm.mm.builder.iwidget.navigation.NavigationMenuSeparator());
				continue;
			}
			var mitem = new dijit.MenuItem({
				label: widgetMenus[i].title,
				disabled: currentSpaceId === null ? true : (!widgetMenus[i].enabled),
				onClick: widgetMenus[i].actionCallBackFunction
			});
			this.addChild(mitem);
		}
	}
});

dojo.declare("com.ibm.mm.builder.iwidget.HomeSpaceMenuItem",dijit.MenuItem,{
	
	templateString:
		 '<tr class="dijitReset dijitMenuItem" dojoAttachPoint="focusNode" waiRole="menuitem" tabIndex="-1"' +
		 'dojoAttachEvent="onmouseenter:_onHover,onmouseleave:_onUnhover,ondijitclick:_onClick">' +
		    '<td class="dijitReset" waiRole="presentation"><div class="dijitMenuItemIcon" dojoAttachPoint="iconNode"></div></td>' +
			'<td class="dijitReset dijitMenuItemLabel" colspan="2">' +
				'<img class="homeSpaceMenuItemIcon" dojoAttachPoint="spaceIconNode" alt="Home Space" title=""></img>' +
				'<span class="homeSpaceMenuItemTitle" widthLimit="134" dojoAttachPoint="containerNode"></span>' +
			'</td>' +
			'<td class="dijitReset dijitMenuArrowCell" waiRole="presentation">' +
			    '<div dojoAttachPoint="arrowWrapper" style="display: none">' +
					'<div class="dijitMenuExpand"></div>' +
					'<span class="dijitMenuExpandA11y">+</span>' +
				'</div>' +
			'</td>' +
		 '</tr>',
		
	postCreate: function(){
		this.spaceIconNode.src = builderConfig.builderPath + "/images/spacemanager/home_space_icon.gif";
		htmlUtil.truncateNodeText(this.containerNode);
		this.containerNode.innerHTML = "<span class='access'>Home Space</span>" +this.containerNode.innerHTML; 
		this.inherited(arguments);
	}
});
})();

}
