if(!dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.configHelper"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.columnlayout.configHelper"] = true;
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.iwidget.columnlayout.configHelper");

dojo.require("dojo.number");
dojo.require("dojox.data.dom");
dojo.require("dijit.form.Slider");

dojo.require("com.ibm.mm.builder.dnd.ColumnSource");
dojo.require("com.ibm.mm.builder.iwidget.columnlayout.defaultSettings");
dojo.require("com.ibm.mm.builder.widget.ColumnWidthResizer");
dojo.require("com.ibm.mm.builder.WidgetLoader");
dojo.require("com.ibm.mm.builder.SkinHelper");

dojo.declare("com.ibm.mm.builder.iwidget.columnlayout.configHelper", null, {
	
	_iContext:null,

	_WID:null,
	
	dropTargetMap:null,
	
	widthOfColumn:null,
	
	colorPicker:null,
	
	columnEditPane:null,
	
	colorPickerAdjustPosX:0,
	colorPickerAdjustPosY:0,
	applyDSToAll:"0",
	
	layoutdata:null,
	
	previousDefaultSkin:null,
	
	configIconMouseOverHandler:null,
	configIconMouseOutHandler:null,
	
	columnAttrRestoreJsonObj: null,
	
	currentPageMode:"view",
	
	layoutObject:null,
	
	constructor:function (icontext) {
        this._iContext = icontext;
		this._WID = "_" + icontext.widgetId + "_";
		this.dropTargetMap = [];
		this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.iwidget.columnlayout.configHelper");
		this.colorPickerAdjustPosX = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosX;
		this.colorPickerAdjustPosY = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.ColorPickerAdjustPosY;
		
		dojo.connect(window, "onresize", dojo.hitch(this, this._resizeColumns));
    },
	
	/**
	 * init the container
	 * create the TD under <tr id="_IWID_TR"> according to the data returned from page content
	 */
	initContainerWidget:function(){
		try{
			this.setAttributeToColumnLayoutBean();
			
			var widgetId = this._iContext.widgetId;			
			
			var attr = this._iContext.getiWidgetAttributes();
			var columnLayoutSkin = attr.getItemValue("skin");
			
			if (columnLayoutSkin!==null){
				com.ibm.mm.builder.columnLayoutBean.setSelectedSkin(columnLayoutSkin);
			}
			this.previousDefaultSkin = columnLayoutSkin;
			
			var numOfColumn = parseInt(com.ibm.mm.builder.columnLayoutBean.getColumnsJSONObject().columnNumber,10);
			com.ibm.mm.builder.columnLayoutBean.setCurrentColumnNum(numOfColumn);	
			this.widthOfColumn = this.resetWidthOfColumn();	
			
			dojo.byId(this._WID+"container").innerHTML = "";
			//init the widthOfColumn object 
			//widthOfColumn is a json object which will contain all the width value of each column
			var root = document.getElementById(widgetId);
			var oneTD,sizerDiv;
			// if this is a new page, numOfColumn should be 0.
			if (numOfColumn === 0){
				//create the default column lay out (3 column layout)
				com.ibm.mm.builder.columnLayoutBean.setCurrentColumnNum(3);	
				this.widthOfColumn['1'] = "350px";
				this.widthOfColumn['2'] = "350px";
				this.widthOfColumn['3'] = "350px";
				var contain = dojo.byId(this._WID+"container");
				for (var j=1;j<=3;j++){
					oneTD = document.createElement("div");
					oneTD.id = this._WID+"Column"+j;
					oneTD.className = com.ibm.mm.builder.constant.columnLayoutClass;
					oneTD.style.width = this.widthOfColumn[""+j];
					contain.appendChild(oneTD);
					if (j!=3){
						sizerDiv = document.createElement("div");
						sizerDiv.id = this._WID+"Sizer"+j;
						sizerDiv.className = "sizer";
						sizerDiv.style.width = "10px";
						contain.appendChild(sizerDiv);	
					}	
				}
			}else{
				//create the columns according to the page content returned
				com.ibm.mm.builder.columnLayoutBean.setCurrentColumnNum(numOfColumn);	
				var theTR = dojo.byId(this._WID+"container");
				for (var x=1;x<=numOfColumn;x++){
					oneTD = document.createElement("div");
					oneTD.id = this._WID+"Column"+x;
					oneTD.className = com.ibm.mm.builder.constant.columnLayoutClass;
					//oneTD.style.width = this.widthOfColumn[""+x];
					//dojo.style(oneTD, "width", this.widthOfColumn[""+x]);
					theTR.appendChild(oneTD);
					if (x!=numOfColumn){
						sizerDiv = document.createElement("div");
						sizerDiv.id = this._WID+"Sizer"+x;
						sizerDiv.className = "sizer";
						sizerDiv.style.width = "10px";
						theTR.appendChild(sizerDiv);
					}
				}
				for (var i = 1; i <= numOfColumn; i++) {
					this._resetColumnWidth(i);
				}
			}
			this.initSizer(this.currentPageMode == "edit");
		}catch(ex){
			this.LOGGER.severe("initContainerWidget",dojo.string.substitute(com.ibm.mm.builder.coreWidgetsMessages.E_COLUMN_LAYOUT_INIT_1,[ex.message]));
		}
		dojo.subscribe("ColorChanged",this,"checkColorChanged");
	},
		
	checkColorChanged:function(indicator){
		if (dojo.byId(indicator+"_checkBox")){
			dojo.byId(indicator+"_checkBox").checked = true;
		}
	},
	
	/**
	 * init the resizer, create ColumnWidthResizer dojo object for the sizer div in current page
	 */
	initSizer:function(mode){
		var sizers = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass("sizer",dojo.byId(this._WID+"container"));
		var maxZIndexInt = com.ibm.mm.builder.skinHelper.getMaxZOrder(this._iContext.widgetId);	
		var len_sizers = sizers.length;
		for (var x=0;x<len_sizers;x++){
			var oneSizer = sizers[x];
			if (oneSizer.innerHTML == ""){
				var sizerId = oneSizer.id;
				var idNum = sizerId.substr(sizerId.length - 1, sizerId.length);
				var num = parseInt(idNum,10);
				var rightNum = num + 1;
				var leftColumnId = this._WID+"Column"+num;
				var rightColumnId = this._WID+"Column"+rightNum;
				var sizerSubDiv = document.createElement("div");
				sizerSubDiv.id = sizerId+"_div";
				oneSizer.appendChild(sizerSubDiv);
				dijit.registry.remove(sizerId+"_div");
				new com.ibm.mm.builder.widget.ColumnWidthResizer({wid:sizerId+"_div",visible:mode,leftColumnId:leftColumnId,rightColumnId:rightColumnId,zIndex:maxZIndexInt,columnContainer:this._WID+"container",columnLayoutID:this._iContext.widgetId, configHelper:this, leftColumnIndex:num, rightColumnIndex:rightNum},sizerSubDiv);	// JSLINT-IGNORE: deprecated code in mashup 3.0						
			}
		}
	},
		
	adjustContainerMinHeight:function(){
		var containerId = this._WID+"container";
		var allCols = dojo.query("."+com.ibm.mm.builder.constant.columnLayoutClass, dojo.byId(containerId));
		var allResizers = dojo.query(".columnWidthResizer", dojo.byId(containerId));
		var maximumHeight = 0;
		var num = allCols.length;
		for (var i=0;i<num;i++){
			var hei = dojo.contentBox(allCols[i]).h;
			if (hei>maximumHeight){
				maximumHeight = hei;
			}
		}
		// TODO: 900 is the default minimum height of each column, change to contant
		var colBorder = 0;
		var k=0;
		var resizerNum = allResizers.length;
		for (k=0;k<num;k++){
			var theColBorder = parseInt(allCols[k].style.borderWidth,10);
			if (colBorder < theColBorder){
				colBorder = theColBorder;
			}
		}
		var containerHeight;
		if (maximumHeight>900){ 	
			for (var j=0;j<num;j++){
				allCols[j].style.minHeight = maximumHeight + "px";
				if (dojo.isIE == 6) {
					allCols[j].style.height = maximumHeight + "px";
				}					
			}
			for (k=0;k<resizerNum;k++){
				allResizers[k].style.minHeight = maximumHeight + "px";
				if (dojo.isIE == 6) {
					allResizers[k].style.height = maximumHeight + "px";
				}	
			}
			containerHeight = maximumHeight + 2*colBorder;
			dojo.byId(containerId).style.minHeight = containerHeight + "px";
			if (dojo.isIE == 6) {
				dojo.byId(containerId).style.height = containerHeight + "px";
			}
		}else{
			containerHeight = 900 + 2*colBorder;
			dojo.byId(containerId).style.minHeight = containerHeight + "px";
			if (dojo.isIE == 6) {
				dojo.byId(containerId).style.height = containerHeight + "px";
			}		
		}
	},

	addDropTarget:function(columnID,dropTarget){
		var obj = {};
		obj.id = columnID;
		obj.dropObject = dropTarget;
		this.dropTargetMap.push(obj);
	},
		
	findDropTarget:function(columnID){
		var arr = this.dropTargetMap;
		for (var i=0;i<arr.length;i++){
			var obj = arr[i];
			if (obj.id == columnID){
				return obj.dropObject;
			}
		}
		return null;
	},
	
	deleteDropTarget:function(columnID){
		var arr = this.dropTargetMap;
		for (var i=0;i<arr.length;i++){
			var obj = arr[i];
			if (obj.id == columnID){
				this.dropTargetMap.pop(obj);
			}
		}		
	},
	
	destroyAllTargets:function(){
		var arr = this.dropTargetMap;
		for (var i=0;i<arr.length;i++){
			var obj = arr[i];
			if (obj.dropObject){
				obj.dropObject.destroy();
			}
		}
		this.dropTargetMap = [];			
	},
			
	fitScreenHeight:function(){
		var container = dojo.byId(this._WID+"container");
		if (typeof container != "undefined" ){
			var pos = dojo._abs(container);
			var size = dojo._getMarginBox(container);
			var pageSize = com.ibm.mm.builder.utils.layoutUtil.getPageSize();
			var newHeight;
			//update the 70 and 100 as the height of navigation, banner and palette
			if(this.currentPageMode == "edit"){
				newHeight = pageSize - pos.y + 70;
			}else{
				newHeight = pageSize - pos.y + 100;
			}
			var curMinHeight = parseInt(container.style.minHeight,10);
			if (dojo.isIE == 6) {
				curMinHeight = parseInt(container.style.height,10);
			}
			if (curMinHeight < newHeight){
				container.style.minHeight = newHeight + "px";
				if (dojo.isIE == 6) {
					container.style.height = newHeight + "px";
				}
				var allCols = dojo.query("."+com.ibm.mm.builder.constant.columnLayoutClass, container);	
				var allResizers = dojo.query(".columnWidthResizer", container);
				var num = allCols.length;
				var resizerNum = allResizers.length;	
				for (var j=0;j<num;j++){
					var curNewHeight = newHeight - 2 * parseInt(allCols[j].style.borderWidth,10);
					allCols[j].style.minHeight = curNewHeight + "px";
					if (dojo.isIE == 6) {
						allCols[j].style.height = curNewHeight + "px";
					}						
				}	
				for (var k=0;k<resizerNum;k++){
					allResizers[k].style.minHeight = newHeight + "px";
				}							
			}
		}
	},
		
	setAttributeToColumnLayoutBean:function(){
		var attr = this._iContext.getiWidgetAttributes();
		var columnsString = attr.getItemValue("columns");
		var columnAttrString = attr.getItemValue("columnattributes");
		var pageAttrString = attr.getItemValue("pageattributes");
		var columnsJSONObject = dojo.fromJson(columnsString);
		var columnAttrJSONObject = dojo.fromJson(columnAttrString);
		var pageAttrJSONObject = dojo.fromJson(pageAttrString);
		
		com.ibm.mm.builder.columnLayoutBean.setColumnsJSONObject(columnsJSONObject);	 
		com.ibm.mm.builder.columnLayoutBean.setColumnAttrJSONObject(columnAttrJSONObject);	 
		com.ibm.mm.builder.columnLayoutBean.setPageAttrJSONObject(pageAttrJSONObject);		
	},	
	
	/**
	 * initialize all the configuration pane's input
	 */
	initConfiguration:function(){
		var columnsJSONObject = com.ibm.mm.builder.columnLayoutBean.getColumnsJSONObject();	
		var columnAttrJSONObject = com.ibm.mm.builder.columnLayoutBean.getColumnAttrJSONObject();
		var pageAttrJSONObject = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();	 
		this.setPageProperties(true,pageAttrJSONObject);
		this.setColumnProperties(true,columnsJSONObject,columnAttrJSONObject,pageAttrJSONObject);
		this.setWidgetProperties(true,pageAttrJSONObject);
		this.columnAttrRestoreJsonObj = null;
	},
	
		
	setPageProperties:function(/*boolean*/init,pageAttrJSONObject){
		// ==========================Page Properties==========================
		// init Background color of page
		dojo.byId(this._WID + "pageBgcolor").value = pageAttrJSONObject.pageBgColor;
		var bgColorNode = dojo.byId(this._WID + "pageBgColorIndicator");
		var bgColor = pageAttrJSONObject.pageBgColor;
		bgColorNode.style.backgroundColor = bgColor;
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(bgColorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_COLOR);		
	
		// add title for input url	
		var pageBgImageURLInput = dojo.byId(this._WID + "pageBgImageURL_input");
		dojo.attr(pageBgImageURLInput,"title",com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGEBGIMAGEURL_INPUT);
		// init the background image
		this.backgroundImageType = pageAttrJSONObject.pageBgImageType;
		var selectNone = false;
		var selectURL = false;
		var moreProp;
		if (this.backgroundImageType == "URL"){
			selectURL = true;
			dojo.byId(this._WID + "pageBgImageURL_input").value = pageAttrJSONObject.pageBgImage;
			moreProp = dojo.byId(this._WID + "urlMoreProperties");
			moreProp.style.display = "";
		}else{
			selectNone = true;
			moreProp = dojo.byId(this._WID + "urlMoreProperties");
			moreProp.style.display = "none";
		}	
		var noneTitle = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_IMAGE + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_NONE;
		dojo.byId(this._WID + "pageBgImageNone").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"BGIType","0","eval(" + this._WID + "iContext.iScope().selectBGINone())",selectNone,noneTitle);
		var urlTitle = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_IMAGE + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_PAGE_BG_URL;
		dojo.byId(this._WID + "pageBgImageURL").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"BGIType","1","eval(" + this._WID + "iContext.iScope().selectBGIURL())",selectURL,urlTitle);
			
		// init image property
		var imagePropSelection = dojo.byId(this._WID + "ImagePropSelection");
		imagePropSelection.options[com.ibm.mm.builder.utils.layoutUtil.getImagePropSelectIndex(pageAttrJSONObject.backgroundimageproperty)].selected = true;
		// add title dynamically...
		dojo.attr(imagePropSelection,"title", com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BG_IMAGE_PROPERTIES + ":" + imagePropSelection.options[imagePropSelection.selectedIndex].innerHTML);
		dojo.connect(imagePropSelection,"onchange",this,function() {
			var imagePropSelection = dojo.byId(this._WID + "ImagePropSelection");
			var selectedOption = imagePropSelection.options[imagePropSelection.selectedIndex];
			dojo.attr(imagePropSelection,"title", com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BG_IMAGE_PROPERTIES + ":" + selectedOption.innerHTML);
		});
		// init the background image Transparency option
		
		var bTslider = dijit.byId(this._WID + "bgiTransparency");
		if(bTslider && !init){
			bTslider.setValue(pageAttrJSONObject.bgImageOpacity);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this._WID,"bgiTransparency","bgiTransparencyValue",pageAttrJSONObject.bgImageOpacity,"%","100","5");
		}
		
		// init Page border 
		var pageBorder = pageAttrJSONObject.pageBorder;
		var pageBorderNode = dojo.byId(this._WID + "pageBorderSelection");
		pageBorderNode.options[com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex(pageBorder)].selected = true;
		// add title dynamically...
		pageBorderNode.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BORDER + ":" + pageBorderNode.options[pageBorderNode.selectedIndex].innerHTML);
		dojo.connect(pageBorderNode,"onchange",this,function() {
			var pageBorder = pageAttrJSONObject.pageBorder;
			var selectedOption = pageBorderNode.options[pageBorderNode.selectedIndex];
			pageBorderNode.setAttribute("title", com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BORDER + ":" + selectedOption.innerHTML);
		});
		// init Page border color
		dojo.byId(this._WID + "pageBorderColor").value = pageAttrJSONObject.pageBorderColor;
		var pgBorderColorNode = dojo.byId(this._WID + "pageBorderColorIndicator");
		var pgBorderColor = pageAttrJSONObject.pageBorderColor;
		pgBorderColorNode.style.backgroundColor = pgBorderColor;						
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(pgBorderColorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BORDER_COLOR);
	
		// init Page margin
		var pMslider = dijit.byId(this._WID + "pageMarginSlider");
		dojo.byId(this._WID  + "pageMarginSliderGraphic").style.width = pageAttrJSONObject.pageMargin + "px";
		if(pMslider && !init){
			pMslider.setValue(pageAttrJSONObject.pageMargin);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this._WID,"pageMarginSlider","pageMarginSliderValue",pageAttrJSONObject.pageMargin,"","20","1","pageMarginSliderGraphic");
		}
		// ==========================Page Properties end==========================
		
	},
		
	setColumnProperties:function(/*boolean*/init,columnsJSONObject,columnAttrJSONObject,pageAttrJSONObject){
		// ==========================Column Properties============================
		// init the Number of columns
		var columnNumberSelection = dojo.byId(this._WID + "columnNumberSelection");
		var columnNum = columnsJSONObject.columnNumber;
		var columnSelectedIndex = columnNum - 1;
		columnNumberSelection.options[columnSelectedIndex].selected = true;

		// init the width between column
		var wBCslider = dijit.byId(this._WID + "widBetweenColsSlider");
		dojo.byId(this._WID  + "widBetweenColsSliderGraphic").style.width = pageAttrJSONObject.widthBetweenColumn + "px";
		if(wBCslider && !init){
			wBCslider.setValue(pageAttrJSONObject.widthBetweenColumn);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this._WID,"widBetweenColsSlider","widBetweenColsSliderValue",pageAttrJSONObject.widthBetweenColumn,"","50","1","widBetweenColsSliderGraphic");
		}
		// init the all column bgcolor, border style
		dojo.byId(this._WID + "allColumnBgColor").value = columnAttrJSONObject.all.bgcolor;
		var allColumnBgColorNode = dojo.byId(this._WID + "allColumnBgColorIndicator");
		var allColumnBgColor = columnAttrJSONObject.all.bgcolor;	
		allColumnBgColorNode.style.backgroundColor = allColumnBgColor;
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(allColumnBgColorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PAGE_BACKGROUND_COLOR);
		
		if (columnAttrJSONObject.all.enabled == "1"){
			if(dojo.isIE==6){
				setTimeout(dojo.hitch(this,function(){
					dojo.byId(this._WID + "allColumnBgColorIndicator_checkBox").checked = true;
				}),1);
			}else{
				dojo.byId(this._WID + "allColumnBgColorIndicator_checkBox").checked = true;
			}
		}else{
			dojo.byId(this._WID + "allColumnBgColorIndicator_checkBox").checked = false;
		}
		var allBorder = columnAttrJSONObject.all.border;
		dojo.byId(this._WID + "allColumnBorderSelection").options[com.ibm.mm.builder.utils.layoutUtil.getPageBorderSelectIndex(allBorder)].selected = true;
		dojo.byId(this._WID + "allColumnBorderColor").value = columnAttrJSONObject.all.bordercolor;
		var allBorderColorNode = dojo.byId(this._WID + "allColumnBorderColorIndicator");
		allBorderColorNode.style.backgroundColor = columnAttrJSONObject.all.bordercolor;
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._setTitleForColorNode(allBorderColorNode,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_COLUMN_BORDER_COLOR);
		if (init){
			this.initTheColumnNumber(columnAttrJSONObject);
		}else{
			this.changeColumnNumber(columnAttrJSONObject);
		}
		// ==========================Column Properties end========================
	},

	setWidgetProperties:function(/*boolean*/init,pageAttrJSONObject){
		// ==========================Widget Properties============================
		// init the magin between widgets in the same column: widthBetweenWidgets'
		if(!init){
			com.ibm.mm.builder.iwidget.columnlayout.columnUtil.chooseSkin(pageAttrJSONObject.skin,this._iContext.widgetId);	
		}
		var applyAllusingDSTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN;
		var applyAllWidgetTitle = com.ibm.mm.builder.coreWidgetsStrings.I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN + ":" + com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL;
		
		if (pageAttrJSONObject.applyDefaultSkinToAll=="0"){
			this.applyDSToAll = "0";
			dojo.byId(this._WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","1","eval(" + this._WID + "iContext.iScope().selectDSApllyToExisting())",true,applyAllusingDSTitle);
			dojo.byId(this._WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","0","eval(" + this._WID + "iContext.iScope().selectDSApllyToAll())",false,applyAllWidgetTitle);
		}else{
			this.applyDSToAll = "1";
			dojo.byId(this._WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","0","eval(" + this._WID + "iContext.iScope().selectDSApllyToExisting())",false,applyAllusingDSTitle);
			dojo.byId(this._WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","1","eval(" + this._WID + "iContext.iScope().selectDSApllyToAll())",true,applyAllWidgetTitle);
		}
		
		var vMslider = dijit.byId(this._WID + "vMarginSlider");
		dojo.byId(this._WID  + "vMarginSliderGraphic").style.width = pageAttrJSONObject.widthBetweenWidgets + "px";
		if(vMslider && !init){
			vMslider.setValue(pageAttrJSONObject.widthBetweenWidgets);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this._WID,"vMarginSlider","vMarginSliderValue",pageAttrJSONObject.widthBetweenWidgets,"","50","1","vMarginSliderGraphic");
		}
		
		// init the left and right magin of widgets: widgetLeftRightMargin
		var hMslider = dijit.byId(this._WID + "hMarginSlider");
		dojo.byId(this._WID  + "hMarginSliderGraphic").style.width = pageAttrJSONObject.widgetLeftRightMargin + "px";
		if(hMslider && !init){
			hMslider.setValue(pageAttrJSONObject.widgetLeftRightMargin);
		}else{
			com.ibm.mm.builder.utils.layoutUtil.createSlider(this._WID,"hMarginSlider","hMarginSliderValue",pageAttrJSONObject.widgetLeftRightMargin,"","50","1","hMarginSliderGraphic");				
		}
		// ==========================Widget Properties end========================
	},
		
	selectBGINone:function(){
		this.backgroundImageType = "None";
		var moreProp = dojo.byId(this._WID + "urlMoreProperties");
		moreProp.style.display = "none";
	},
	
	selectBGIURL:function(){
		this.backgroundImageType = "URL";
		var moreProp = dojo.byId(this._WID + "urlMoreProperties");
		moreProp.style.display = "";
	},

	selectDSApllyToExisting:function(){
		this.applyDSToAll = "0";
		dojo.byId(this._WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","1","eval(" + this._WID + "iContext.iScope().selectDSApllyToExisting())",true,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN);
		dojo.byId(this._WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","0","eval(" + this._WID + "iContext.iScope().selectDSApllyToAll())",false,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL);		
	},	
		
	selectDSApllyToAll:function(){
		this.applyDSToAll = "1";
		dojo.byId(this._WID + "applyAllUsingDS").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","0","eval(" + this._WID + "iContext.iScope().selectDSApllyToExisting())",false,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN);
		dojo.byId(this._WID + "applyAllWigets").innerHTML = com.ibm.mm.builder.utils.embedUtil.createRadioButton(this._WID+"DefaultSkinApplyType","1","eval(" + this._WID + "iContext.iScope().selectDSApllyToAll())",true,com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL);
	},
		
	/**
	 * showConfiguration is called when user click the edit icon
	 */
	showConfiguration:function(){
		this.columnEditPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
            id: this._iContext.widgetId + "_edit",
			title: com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_PRO_TITLE,
            type: "config",
            nodeWidth: "760px",
            needModeSwitch: true,
            belongId: this._iContext.widgetId,
            containerBackgroundColor: "white",
			hasRightBottomResizer: false,
			closeCallback: function(){ 
				this.destroy(); 
			}
        });
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {
            newMode: 'edit',
            rootElementId: this.columnEditPane.containerNode
        });
		this.columnEditPane.show();
	},
		
	toChangeColumnMode:function(){
		var configdiv = dojo.byId(this._WID+"layoutWidgetConfigDiv");
		if (configdiv){
			if (this.currentPageMode == "edit"){
				configdiv.style.display = "";
				if (!dojo.isIE || dojo.isIE > 6) {
					this.configIconMouseOverHandler = dojo.connect(dojo.byId(this._WID + "container").parentNode, "onmouseover", this, "showConfigurationIcon");
					this.configIconMouseOutHandler = dojo.connect(dojo.byId(this._WID + "container").parentNode, "onmouseout", this, "hideConfigurationIcon");
					this.configIconOnFocusHandler = dojo.connect(dojo.byId(this._WID + "container"), "onkeypress", this, "showConfigurationIcon");
				} 
			}else{	
				configdiv.style.display = "none";
				if (!dojo.isIE || dojo.isIE > 6) {
					dojo.disconnect(this.configIconMouseOverHandler);
					dojo.disconnect(this.configIconMouseOutHandler);
					dojo.disconnect(this.configIconOnFocusHandler);
				}
			}
		}
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._changeColumnResizerStatus(this.currentPageMode);
				
		var sizers = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass("columnWidthResizer",dojo.byId(this._WID+"container"));
		if (sizers!==null){
			for (var i=0;i<sizers.length;i++){
				var sizerObj = dijit.byId(sizers[i].id);
				if (this.currentPageMode == "edit"){
					sizerObj.toEditMode();
					sizers[i].style.cursor = "e-resize";
				}else{
					sizerObj.toViewMode();
					sizers[i].style.cursor = "pointer";
				}
			}
		}
	},
		
	/**
	 * save the UI input from column layout configuration pane
	 */
	saveConfiguration:function(){
		var columnLayoutBean = com.ibm.mm.builder.columnLayoutBean;
		var columnsJSONObj = columnLayoutBean.getColumnsJSONObject();
        var columnAttrJSONObj = columnLayoutBean.getColumnAttrJSONObject();
        var pageAttrJSONObj = columnLayoutBean.getPageAttrJSONObject();
        
        var formObject = dojo.formToObject(dojo.byId(this._WID + "configurationForm")); // get the form object
		var columnNumber = formObject.columnNumberSelection; // construct the parameters of columns
        
        var widthsObject = {};
		var i = 0;
		for (i = 1; i <= columnNumber; i++) {
            widthsObject[i] = this.widthOfColumn[i + ""];
        }
		dojo.mixin(columnsJSONObj, {
			columnNumber: 	columnNumber,
			widths: 		widthsObject
		});
		columnLayoutBean.setColumnsJSONObject(columnsJSONObj);
        // end the parameters of columns
        
        // construct the parameter of columns attribute
        // first, set all column attr
		dojo.mixin(columnAttrJSONObj.all, {
			enabled: 		dojo.byId(this._WID + "allColumnBgColorIndicator_checkBox").checked ? "1" : "0",
        	bgcolor: 		formObject.allColumnBgColor,
        	border: 		formObject.allColumnBorderSelection,
        	bordercolor: 	formObject.allColumnBorderColor
		});
        // second, set each column attr
        for (i = 1; i <= columnNumber; i++) {
            var columnIndex = builderConfig.isBidi ? columnNumber - i + 1 : i;
			columnAttrJSONObj[columnIndex] = columnAttrJSONObj[columnIndex] || columnLayoutBean.getSingleColumnDefaultSetting();
			dojo.mixin(columnAttrJSONObj[columnIndex], {
				enabled: 		dojo.byId(this._WID + "eachColumnBgColorIndicator" + i + "_checkBox").checked ? "1" : "0",
            	bgcolor: 		dojo.byId(this._WID + "eachColumnBgColor" + i).value,
            	border: 		dojo.byId(this._WID + "columnBorderSelection" + i).value,
            	bordercolor: 	dojo.byId(this._WID + "eachColumnBorderColor" + i).value
			});
        }
        for (var j = columnNumber + 1; j <= 4; j++) {
            if (columnAttrJSONObj[j]) {
                columnAttrJSONObj[j] = columnLayoutBean.getSingleColumnDefaultSetting();
            }
        }
		columnLayoutBean.setColumnAttrJSONObject(columnAttrJSONObj);
        // end the parameter of columns attribute
        
        // construct the parameter of page attribute
		var pageWidthMode = com.ibm.mm.builder.utils.pageWidthChanger.getPageWidthMode();
		dojo.mixin(pageAttrJSONObj, {
			widthBetweenColumn: 		parseInt(dojo.byId(this._WID + "widBetweenColsSliderValue").innerHTML,10),
	        widthBetweenWidgets: 		parseInt(dojo.byId(this._WID + "vMarginSliderValue").innerHTML,10),
	        widgetLeftRightMargin: 		parseInt(dojo.byId(this._WID + "hMarginSliderValue").innerHTML,10),
	        pageBgColor: 				formObject.pageBgcolor,
	        pageBorder: 				formObject.pageBorderSelection,
	        pageBorderColor: 			formObject.pageBorderColor,
	        pageMargin: 				parseInt(dojo.byId(this._WID + "pageMarginSliderValue").innerHTML,10),
	        pageBgImage: 				formObject.pageBgImageURL_input,
	        bgImageOpacity: 			parseInt(dojo.byId(this._WID + "bgiTransparencyValue").innerHTML,10),
	        pageBgImageType: 			this.backgroundImageType,
	        backgroundimageproperty: 	formObject.ImagePropSelection,
	        applyDefaultSkinToAll: 		this.applyDSToAll,
			pageWidthMode:              pageWidthMode.mode,
			pageWidth:                  pageWidthMode.width
		});
        columnLayoutBean.setPageAttrJSONObject(pageAttrJSONObj);
        // end the parameter of page attribute
        var attr = this._iContext.getiWidgetAttributes();
        attr.setItemValue("skin", com.ibm.mm.builder.columnLayoutBean.getSelectedSkin(), false);
        attr.setItemValue("columns", dojo.toJson(columnsJSONObj), false);
        attr.setItemValue("columnattributes", dojo.toJson(columnAttrJSONObj), false);
        attr.setItemValue("pageattributes", dojo.toJson(pageAttrJSONObj), false);
		attr.save();
		
		this.refreshColumnWidth();
	},
	
	applyPageAttributes: function(pageAttrJSONObject){
		var pageBorderIntValue = 0;
		var pageContainer = dojo.byId(this._WID + "container");
		if (pageAttrJSONObject.pageBorder == "none"){
			dojo.addClass(pageContainer,"columnLayoutBorder");
			pageBorderIntValue = 0;
			pageContainer.style.border = 0;
		}else{
			pageContainer.style.border = pageAttrJSONObject.pageBorder + " " + pageAttrJSONObject.pageBorderColor;
			pageBorderIntValue = parseInt(pageAttrJSONObject.pageBorder,10);
		}
       
	    //if the border exist, we should reduce the width of page
		//pageContainer.style.width = (1070 - 2 * pageBorderIntValue) + "px";
		pageContainer.style.width = "100%";
		pageContainer.style.backgroundColor = pageAttrJSONObject.pageBgColor;

		var bgitype = pageAttrJSONObject.pageBgImageType;
		var bgitransparency = pageAttrJSONObject.bgImageOpacity;
		var bgiproperty = pageAttrJSONObject.backgroundimageproperty;
		if (bgitype == "URL"){
			//pageContainer.style.backgroundImage = pageAttrJSONObject.pageBgImage;
			pageContainer.style.backgroundImage = com.ibm.mm.builder.utils.layoutUtil.transformBgIamge(pageAttrJSONObject.pageBgImage);
			if (bgiproperty == "Scale"){
				pageContainer.style.backgroundRepeat = "no-repeat";
				pageContainer.style.backgroundPosition = "left";
			}
			if (bgiproperty == "RepeatX"){
				pageContainer.style.backgroundRepeat = "repeat-x";
				pageContainer.style.backgroundPosition = "left";
			}
			if (bgiproperty == "RepeatY"){
				pageContainer.style.backgroundRepeat = "repeat-y";
				pageContainer.style.backgroundPosition = "left";
			}
			if (bgiproperty == "Repeat"){
				pageContainer.style.backgroundRepeat = "repeat";
			}		
			if (bgiproperty == "Center"){
				pageContainer.style.backgroundRepeat = "no-repeat";
				pageContainer.style.backgroundPosition = "top center";
			}			
			bgitransparency = 100 - bgitransparency;							
			pageContainer.style.opacity = parseInt(bgitransparency,10)/100;
			//pageContainer.style.filter = "alpha(opacity=" + bgitransparency + ")";
		}else{
			pageContainer.style.backgroundImage = "";
			pageContainer.style.backgroundRepeat = "";
			pageContainer.style.backgroundPosition = "";
		}
	},
	
	applyStyleConfiguration:function(){
		var columnsJSONObject = com.ibm.mm.builder.columnLayoutBean.getColumnsJSONObject();	 
		var columnAttrJSONObject = com.ibm.mm.builder.columnLayoutBean.getColumnAttrJSONObject();	
		var pageAttrJSONObject = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();	 
		
		// apply page attribute
		this.applyPageAttributes(pageAttrJSONObject);

		// apply each column attribute style
		var columnNumber = columnsJSONObject.columnNumber;
		for (var i=1;i<columnNumber;i++){
			var oneSizer = dojo.byId(this._WID + "Sizer" + i);
			oneSizer.style.width = pageAttrJSONObject.widthBetweenColumn+"px";
			//change the position of the drag handle
			var dragHandle = dojo.byId(this._WID + "Sizer" + i + "_div_img");
			dragHandle.style.left = pageAttrJSONObject.widthBetweenColumn/2 -5 +"px";
		}
		dojo.byId(this._WID + "Column" + "1").style.marginLeft = pageAttrJSONObject.pageMargin + "px";
		dojo.byId(this._WID + "Column" + columnNumber).style.marginRight = pageAttrJSONObject.pageMargin + "px";
		
		var currentWholeWidth =  parseInt(dojo.style(dojo.byId(this._WID + "container"),"width"),10) || 1070;
		var oneColumn;
		for (var j=1;j<=columnNumber;j++){
			oneColumn = dojo.byId(this._WID+"Column"+j);
			if (columnAttrJSONObject.all.enabled == "1") {
				oneColumn.style.backgroundColor = columnAttrJSONObject.all.bgcolor;
			} else {
				oneColumn.style.backgroundColor = "";
			}
			if (columnAttrJSONObject.all.border == "none"){
				oneColumn.style.border = "0";
			} else{
				oneColumn.style.border = columnAttrJSONObject.all.border + " " + columnAttrJSONObject.all.bordercolor;
			}
		}
		for (j=1;j<=columnNumber;j++){
			if (!com.ibm.mm.builder.iwidget.columnlayout.columnUtil._isDefaultSetting(columnAttrJSONObject[j])){
				oneColumn = dojo.byId(this._WID+"Column"+j);
				if(columnAttrJSONObject[j].enabled == "1"){
					oneColumn.style.backgroundColor = columnAttrJSONObject[j].bgcolor;
				}
				if (columnAttrJSONObject[j].border == "none"){
					oneColumn.style.border = "0";
				}else{
					oneColumn.style.border = columnAttrJSONObject[j].border + " " + columnAttrJSONObject[j].bordercolor;
				}				
			}
		}
		
		var artifactsWidth = 0;
		// apply the width of each column
		for (j=1;j<=columnNumber;j++){
			if ((!com.ibm.mm.builder.iwidget.columnlayout.columnUtil._isDefaultSetting(columnAttrJSONObject[j]))){
				// if column j has user specified border value, then get this value
				if (columnAttrJSONObject[j].border!="none"){
					artifactsWidth = artifactsWidth + 2 * parseInt(columnAttrJSONObject[j].border,10);
				}				
			}else{
				// if column j is not customized, use the default all column setting
				if (columnAttrJSONObject.all.border!="none"){
					artifactsWidth = artifactsWidth + 2 * parseInt(columnAttrJSONObject.all.border,10);
				}					
			}
		}
		artifactsWidth = artifactsWidth + (columnNumber - 1) * parseInt(pageAttrJSONObject.widthBetweenColumn,10);	
		artifactsWidth = artifactsWidth + 2 * parseInt(pageAttrJSONObject.pageMargin,10);
		//fix bug #2015
		//artifactsWidth = artifactsWidth + 2 * pageBorderIntValue;
		var newColumsWidth = currentWholeWidth - artifactsWidth;
		this.ajustColumnWidth(newColumsWidth);
		if(dojo.isIE && dojo.isIE == 6){
			dojo.byId(this._WID+"Column"+"1").style.marginLeft = pageAttrJSONObject.pageMargin/2 + "px";
			dojo.byId(this._WID+"Column"+columnNumber).style.marginRight = pageAttrJSONObject.pageMargin/2 + "px";
		}
		
		//update column width to fit min width restriction
		var pageAttrJson = com.ibm.mm.builder.columnLayoutBean.getPageAttrJSONObject();
		var colWidthReserved = 2*pageAttrJson.widgetLeftRightMargin + 60;
		var adjustWidth = 0, maxWidth = 0, maxWidthIndex = 0;
		for (var x=1;x<=columnNumber;x++){
			var width = parseInt(dojo.style(dojo.byId(this._WID + "Column" + x), "width"),10);
			if(maxWidth < width){
				maxWidth = width;
				maxWidthIndex = x;
			}
			if(width < colWidthReserved){
				//dojo.byId(this._WID + "Column" + x).style.width = colWidthReserved + "px";
				this._setColumnPercentageUsingAbsWidth(x, colWidthReserved);
				adjustWidth += colWidthReserved - width;
			}
		}
		var maxColWidth = parseInt(dojo.style(dojo.byId(this._WID + "Column" + maxWidthIndex), "width"),10);
		this._setColumnPercentageUsingAbsWidth(maxWidthIndex, maxColWidth-adjustWidth);
		
		// update the widget style margin top , margin left , margin right
		this.applyWidgetStyleSetting(pageAttrJSONObject.widthBetweenWidgets,pageAttrJSONObject.widgetLeftRightMargin);
		// end the width of each column	
		this._resizeColumns();
	},
		
	ajustColumnWidth:function(newColumsWidth){
		var difference;
		var oldWidth,newWidth,eachDif;
		var columnWidths = 0;
		var columnNumber = com.ibm.mm.builder.columnLayoutBean.getColumnsJSONObject().columnNumber;
		for (var j=1;j<=columnNumber;j++){
			columnWidths = columnWidths + parseInt(dojo.style(dojo.byId(this._WID+"Column"+j), "width"),10);
		}
		if (newColumsWidth>columnWidths){
			difference =  newColumsWidth - columnWidths;
			eachDif = parseInt(difference / columnNumber,10);
			for (j=1;j<columnNumber;j++){
				oldWidth = parseInt(dojo.style(dojo.byId(this._WID+"Column"+j), "width"),10);
				newWidth = oldWidth + eachDif;
				this._setColumnPercentageUsingAbsWidth(j, newWidth);
			}
			oldWidth = parseInt(dojo.style(dojo.byId(this._WID+"Column"+j), "width"),10);
			newWidth = oldWidth + difference - (columnNumber - 1)*eachDif;
            this._setColumnPercentageUsingAbsWidth(columnNumber, newWidth);			
		}else{
			difference =  columnWidths - newColumsWidth;	
			eachDif = parseInt(difference / columnNumber,10);	
			for (j=1;j<columnNumber;j++){
				oldWidth = parseInt(dojo.style(dojo.byId(this._WID+"Column"+j), "width"),10);
				newWidth = oldWidth - eachDif;
				this._setColumnPercentageUsingAbsWidth(j, newWidth);
			}	
			oldWidth = parseInt(dojo.style(dojo.byId(this._WID+"Column"+j), "width"),10);
			newWidth = oldWidth - (difference - (columnNumber - 1)*eachDif);
			this._setColumnPercentageUsingAbsWidth(columnNumber, newWidth);
		}	
	},
		
	applyWidgetStyleSetting:function(marginTop, marginLeftRight){
		var locationStyle = "margin-top:" + marginTop + "px;margin-left:" + marginLeftRight + "px;margin-right:" + marginLeftRight + "px;";
		var container = dojo.byId(this._WID+"container");
		var iwidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,container);
		if (iwidgets!==null){
			var iwidgetsLen = iwidgets.length;
			for (var k=0;k<iwidgetsLen;k++){
				var onespan = iwidgets[k];
				var locStyle = onespan.getAttribute("locationstyle");
				if (!locStyle) {
					continue;
				}
				locationStyle += locStyle.replace(/margin-\w{3,5}:\d+px;/g,"");
				onespan.setAttribute("locationstyle",locationStyle);
				var widgetSkinDom = dojo.byId(com.ibm.mm.builder.constant.skinIdPrefix + onespan.id);
				if (widgetSkinDom){
					widgetSkinDom.style.marginTop = marginTop + "px";
					widgetSkinDom.style.marginLeft = marginLeftRight + "px";
					widgetSkinDom.style.marginRight = marginLeftRight + "px";
				}					
			}
		}
	},
	
	validateInput:function(){
		if (this.backgroundImageType == "URL") {
			var urlvalue = dojo.byId(this._WID + "pageBgImageURL_input").value;
			if (dojo.trim(urlvalue) == ""){
				dojo.byId(this._WID + "URLRequired_text").style.display = "";
				return false;
			}else{
				dojo.byId(this._WID + "URLRequired_text").style.display = "none";
				return true;
			}
		}
		return true;		
	},
	
	/**
	 * saveInput is called when click the save button in configuration pane
	 * things to do in saveInput:
	 * 1. save the selected layout, and each column width
	 * 2. move existing iWidgets in the column which have been deleted
	 * 3. save the selected skin type
	 * 4. hide the configuration pane
	 */
	saveInput:function(){
		if(!this.validateInput()){
			return;
		}		
		var confForm = dojo.byId(this._WID + "configurationForm");
	 	var formObject = dojo.formToObject(confForm);
		// selected column is 1,2,3,4
		var selectedColumn = parseInt(formObject.columnNumberSelection,10);
		var oldColumnNumber = com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum();
		var x,oneTD,oneid,sizerDiv;
		if (selectedColumn != oldColumnNumber){
			// save the selected layout and each column's width
			var num = parseInt(selectedColumn,10);
			
			this.widthOfColumn = {};
			var theTR = dojo.byId(this._WID+"container");
			
			this.initWidthOfColumn(num);
			// move the existing iWidgets in the deleted column
			if (oldColumnNumber<num){
				// if the user wants to add column number
				// just add the blank column
				// clean the old rightest column's marginRight
				var rightestCol = dojo.byId(this._WID + "Column" + oldColumnNumber);
				rightestCol.style.marginRight = "0px";
				// end clean
				for (x = oldColumnNumber + 1; x <= num; x++) {
					if ((x - 1) > 0 && (x - 1 <= num)) {
						var curIndex = x - 1;
						sizerDiv = document.createElement("div");
						sizerDiv.id = this._WID + "Sizer" + curIndex;
						sizerDiv.className = "sizer";
						sizerDiv.style.width = "10px";
						theTR.appendChild(sizerDiv);
					}
					oneTD = document.createElement("div");
					oneTD.id = this._WID + "Column" + x;
					oneTD.className = com.ibm.mm.builder.constant.columnLayoutClass;
					theTR.appendChild(oneTD);
					this.layoutObject.sourceContainer[x] = com.ibm.mm.builder.iwidget.columnlayout.columnUtil.createColumnSource(oneTD,this.layoutObject);
				}	
				for (x=1;x<=num;x++){
					oneid = this._WID+"Column"+x;
					oneTD = dojo.byId(oneid);
					oneTD.style.width = this.widthOfColumn[""+x];
				}
				this.initSizer(true);		
			}else{
				// if the user wants to dec column number
				// first get all the existing widgets from the column user wants to delete
				// then delete the column
				var movedWidgets = [];
				var tdToDestroy = [];
				//var mmutil = com.ibm.mm.builder.htmlUtil;
				for (x=oldColumnNumber;x>num;x--){
					oneid = this._WID+"Column"+x;
					oneTD = dojo.byId(oneid);
					var widgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,oneTD);
					var wLen = widgets.length;
					for (var y=0;y<wLen;y++){
						widgets[y].setAttribute("layoutdata",this.layoutdata + "column:" + num);
						var skinid = com.ibm.mm.builder.constant.skinIdPrefix+ widgets[y].id;
						movedWidgets.push(dojo.byId(skinid));
					}
					tdToDestroy.push(oneTD);
					oneTD.style.dispaly = "none";
					if ((x - 1)>0){
						var curSizerIndex = x - 1;
						var sizerid = this._WID+"Sizer"+curSizerIndex;
						sizerDiv = dojo.byId(sizerid);
						dojo.destroy(sizerDiv);	
					}
					this.layoutObject.sourceContainer[x].destroy();
					this.layoutObject.sourceContainer.splice(x,1);
				}
				var lastColumn = dojo.byId(this._WID+"Column"+num);
				var widgetLen = movedWidgets.length;
				// get the last row value of the widget in lastColumn.
				var rowNumberBase = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,lastColumn).length;
				for (x=0;x<widgetLen;x++){
					rowNumberBase = rowNumberBase + 1;
					lastColumn.appendChild(movedWidgets[x]);
					// reset the row value to the new appended widget.
					if (movedWidgets[x].id.indexOf(com.ibm.mm.builder.constant.skinIdPrefix)!=-1){
						var wid = movedWidgets[x].id.replace(com.ibm.mm.builder.constant.skinIdPrefix,"");
						var newLayoutData = com.ibm.mm.builder.iwidget.columnlayout.columnUtil._updateRow(dojo.byId(wid).getAttribute("layoutdata"), rowNumberBase);
						dojo.byId(wid).setAttribute("layoutdata",newLayoutData);						
					}
				}
				var tdLen = tdToDestroy.length;
				for (x=0;x<tdLen;x++){
					var tdid = tdToDestroy[x].id;
					dojo.destroy(tdToDestroy[x]);
					this.deleteDropTarget(tdid);
				}				
				// restart the drop target
				var curTarget = this.findDropTarget(this._WID+"Column"+num);
				if (curTarget!==null){
					curTarget.startup();	
				}
				for (x=1;x<=num;x++){
					oneid = this._WID+"Column"+x;
					oneTD = dojo.byId(oneid);
					oneTD.style.width = this.widthOfColumn[""+x];
				}			
			}
		}else{
			// update the width of each column
		}
		com.ibm.mm.builder.columnLayoutBean.setCurrentColumnNum(selectedColumn);
		// change widget skins
		this.changeWidgetSkin();
		
		this.saveConfiguration();
		
		this.previousDefaultSkin = com.ibm.mm.builder.columnLayoutBean.getSelectedSkin();
		
		if (this.columnEditPane!==null){
			if (this.columnEditPane.open){
				this.columnEditPane.hide();	
			}
		}
		
		//save the page attributes
		var jsonStr=com.ibm.mm.builder.utils.iwidgetUtil.dumpItemSetsToJSON(this._iContext.getiWidgetAttributes());
		var layoutWidgetAttributes = dojo.fromJson(jsonStr);
		
		var metadata = {};
		var columnAttributes = dojo.fromJson(layoutWidgetAttributes.columnattributes);
		var pageAttributes = dojo.fromJson(layoutWidgetAttributes.pageattributes);
		var columns = dojo.fromJson(layoutWidgetAttributes.columns);
		
		for (var key in columnAttributes) {
			if (key == "all" || eval(key) <= eval(columns.columnNumber)) { // JSLINT-IGNORE:
				metadata["columnattributes_" + key] = dojo.toJson(columnAttributes[key]);
			}
		}
		
		for(key in pageAttributes){ // JSLINT-IGNORE:
			metadata["pageattributes_" + key] = pageAttributes[key];
		}
		
		for(key in layoutWidgetAttributes){
			if (key != "columnattributes" && key != "pageattributes") {
				metadata[key] = layoutWidgetAttributes[key];
			}
		}
		
		//com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(metadata);
		var allColumnAttributes = [];
		for(var i = 1; i <= 4; i++){
			allColumnAttributes.push("columnattributes_" + i);
		}
		com.ibm.mm.builder.utils.enablerUtil.removePageMetaData(allColumnAttributes);
		com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(metadata);
		
		this.adjustContainerMinHeight();
		this.fitScreenHeight();
		com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().setDirty(true);
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._iContext.widgetId,"onModeChanged", {newMode:'view'});	
	},
	
	savePageWidthMode : function(pageWidthMode) {
	   var attr = this._iContext.getiWidgetAttributes();
	   var pageAttrString = attr.getItemValue("pageattributes");
	   var pageAttrJSONObject = dojo.fromJson(pageAttrString);
	   pageAttrJSONObject.pageWidthMode = pageWidthMode.mode;
	   pageAttrJSONObject.pageWidth = pageWidthMode.width;
	   attr.setItemValue("pageattributes", dojo.toJson(pageAttrJSONObject));
	   attr.save();
	   
	   var metadata = {
		 "pageattributes_pageWidthMode" : pageWidthMode.mode,
		 "pageattributes_pageWidth" : pageWidthMode.width
	   };
	   com.ibm.mm.builder.utils.enablerUtil.setPageJSONMetaData(metadata);
	},
	
	getPageWidthMode : function(attr) {
		var pageAttrString = attr.getItemValue("pageattributes");
		var pageAttrJSONObject = dojo.fromJson(pageAttrString);
		return {
			"mode" : pageAttrJSONObject.pageWidthMode || "fixed",
			"width" : pageAttrJSONObject.pageWidth || 1070
		};
	},

	/**
	 * update all the widgets' skin in column layout.
	 */
	changeWidgetSkin : function(){
		var container = dojo.byId(this._WID+"container");
		var iwidgets = dojo.query("." + com.ibm.mm.builder.constant.mmIWidget,container);
		var k = 0;
		var onespan = null;
		if (iwidgets!==null){
			var iwidgetsLen = iwidgets.length;
			if (this.applyDSToAll == "1"){
				for (k=0;k<iwidgetsLen;k++){
					onespan = iwidgets[k];
					onespan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, com.ibm.mm.builder.columnLayoutBean.getSelectedSkin());
					this.layoutObject.processLocationWhenChangeSkin(onespan.id);
					com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(onespan);
				}	
			} else {
				for (k=0;k<iwidgetsLen;k++){
					onespan = iwidgets[k];
					if (onespan.getAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin)==this.previousDefaultSkin){
						onespan.setAttribute(com.ibm.mm.builder.constant.widget_span_attr_skin, com.ibm.mm.builder.columnLayoutBean.getSelectedSkin());
						this.layoutObject.processLocationWhenChangeSkin(onespan.id);
						com.ibm.mm.builder.utils.iwidgetUtil.updateWidgetInstance(onespan);
					}
				}
			}
		}
	},			
	
	cancelInput:function(){
		com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this._iContext.widgetId, "onModeChanged", {newMode:'view'});
		
		var att = this._iContext.getiWidgetAttributes();
		var skinFromAttr = att.getItemValue("skin");
		com.ibm.mm.builder.columnLayoutBean.setSelectedSkin(skinFromAttr);			
	},
	
	showMorePageProperty:function(){
		var morePropText = dojo.byId(this._WID + "pagePropertiesMore");
		var moreProp = dojo.byId(this._WID + "pageMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_LESS){
			morePropText.title = morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MORE;
			moreProp.style.display = "none";
		}else{
			morePropText.title = morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_LESS;
			moreProp.style.display = "";			
		}	
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(moreProp);	
	},
	
	showMorePagePropertyWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) {
			return true;
		}		
		this.showMorePageProperty();
	},
		
	showMoreColumnProperty:function(){
		var morePropText = dojo.byId(this._WID + "colPropertiesMore");
		var moreProp = dojo.byId(this._WID + "colMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_LESS){
			morePropText.title = morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MORE;
			moreProp.style.display = "none";
		}else{
			morePropText.title = morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_LESS;
			moreProp.style.display = "";			
		}		
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(moreProp);	
	},
	
	showMoreColumnPropertyWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) {
			return true;
		}		
		this.showMoreColumnProperty();
	},
		
	showMoreWidgetProperty:function(){
		var morePropText = dojo.byId(this._WID + "widgetPropertiesMore");
		var moreProp = dojo.byId(this._WID + "widgetMoreProperties");
		if (morePropText.innerHTML == com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_LESS){
			morePropText.title = morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MORE;
			moreProp.style.display =  "none";
		}else{
			morePropText.title = morePropText.innerHTML = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_LESS;
			moreProp.style.display = "";			
		}	
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(moreProp);	
	},
	
	showMoreWidgetPropertyWithKey: function(event){
    	var keyCode = event.keyCode;
    	if (keyCode != dojo.keys.ENTER) {
			return true;
		}		
		this.showMoreWidgetProperty();
	},
		
	restoreDefaultConfiguration:function(){
		this.restoreDefaultPageConfiguration();
		this.restoreDefaultColConfiguration();
		this.restoreDefaultWidgetConfiguration();
	},
	
	restoreDefaultPageConfiguration:function(){
		var att = this._iContext.getiWidgetAttributes();
		var defaultSetting = com.ibm.mm.builder.columnLayoutBean.getPageDefaultSetting();
		var pageAttrJSONObject = null;
		if (att !== null) {
			var pageAttrString = att.getItemValue("pageattributes");
			pageAttrJSONObject = dojo.fromJson(pageAttrString);
			pageAttrJSONObject.pageBgColor = defaultSetting.pageBgColor;
			pageAttrJSONObject.pageBgImageType = defaultSetting.pageBgImageType;
			pageAttrJSONObject.pageBgImage = defaultSetting.pageBgImage;
			pageAttrJSONObject.backgroundimageproperty = defaultSetting.backgroundimageproperty;
			pageAttrJSONObject.bgImageOpacity = defaultSetting.bgImageOpacity;
			pageAttrJSONObject.pageBorder = defaultSetting.pageBorder;
			pageAttrJSONObject.pageBorderColor = defaultSetting.pageBorderColor;
			pageAttrJSONObject.pageMargin = defaultSetting.pageMargin;
		}
		this.setPageProperties(false,pageAttrJSONObject);	
		var urlRequired = dojo.byId(this._WID + "URLRequired_text");
		urlRequired.style.display="none";
	},
		
	restoreDefaultColConfiguration:function(){
		var att = this._iContext.getiWidgetAttributes();
		var defaultSetting = com.ibm.mm.builder.columnLayoutBean.getColDefaultSetting();
		var columnsJSONObject,columnAttrJSONObject,pageAttrJSONObject;
		if (att !== null) {
			var columnsString = att.getItemValue("columns");
			var columnAttrString = att.getItemValue("columnattributes");
			var pageAttrString = att.getItemValue("pageattributes");
			
			columnsJSONObject = dojo.fromJson(columnsString);
			columnsJSONObject.columnNumber = defaultSetting.columnNumber;
			columnsJSONObject.widths = defaultSetting.widths;
			
			columnAttrJSONObject = dojo.fromJson(columnAttrString);
			columnAttrJSONObject.all = com.ibm.mm.builder.columnLayoutBean.getSingleColumnDefaultSetting();
			for(var i=1;i<=columnsJSONObject.columnNumber;i++){
				columnAttrJSONObject[i] = com.ibm.mm.builder.columnLayoutBean.getSingleColumnDefaultSetting();
			}
			pageAttrJSONObject = dojo.fromJson(pageAttrString);
			pageAttrJSONObject.widthBetweenColumn = defaultSetting.widthBetweenColumn;			
		}
		this.setColumnProperties(false,columnsJSONObject,columnAttrJSONObject,pageAttrJSONObject);	
		this.columnAttrRestoreJsonObj	= com.ibm.mm.builder.columnLayoutBean.getColDefaultSetting();
	},
		
	restoreDefaultWidgetConfiguration:function(){
		var att = this._iContext.getiWidgetAttributes();
		var defaultSetting = com.ibm.mm.builder.columnLayoutBean.getWidgetDefaultSetting();
		var pageAttrJSONObject = null;
		if (att !== null) {
			var pageAttrString = att.getItemValue("pageattributes");
			pageAttrJSONObject = dojo.fromJson(pageAttrString);
			pageAttrJSONObject.skin = defaultSetting.skin;
			pageAttrJSONObject.widthBetweenWidgets = defaultSetting.widthBetweenWidgets;
			pageAttrJSONObject.widgetLeftRightMargin = defaultSetting.widgetLeftRightMargin;
			pageAttrJSONObject.applyDefaultSkinToAll = defaultSetting.applyDefaultSkinToAll;
			this.applyDSToAll = "0";
			this.previousDefaultSkin = com.ibm.mm.builder.columnLayoutBean.getSelectedSkin();
		}
		this.setWidgetProperties(false,pageAttrJSONObject);
	},

	/**
	 * show the column background color picker
	 */	
	showColBgColorPicker:function(indicatorId){
		this._toShowColorPicker(indicatorId,"columnBgColor");
	},	
	
	/**
	 * show the page border color picker
	 */		
	showPageBorderColorPicker:function(){
		if (dojo.byId(this._WID + "pageBorderSelection").selectedIndex === 0) {
			return;
		}
		this._toShowColorPicker("pageBorderColorIndicator","pageBorderColor");
	},
	
	/**
	 * show the page background color picker
	 */		
	showPageBgColorPicker:function(){
		if (this.backgroundImageType == "URL") {
			return;
		}
		this._toShowColorPicker("pageBgColorIndicator","pageBgcolor");
	},	

	/**
	 * show all column background color picker
	 */	
	showAllColBgColorPicker:function(){
		this._toShowColorPicker("allColumnBgColorIndicator","allColumnBgColor");	
	},	

	/**
	 * show all column border color picker
	 */
	showAllColBorderColorPicker:function(){
		if (dojo.byId(this._WID + "allColumnBorderSelection").selectedIndex === 0) {
			return;
		}
		this._toShowColorPicker("allColumnBorderColorIndicator","allColumnBorderColor");	
	},

	_toShowColorPicker:function(indicatorId,colorDivId){
		var indicatorX = dojo._abs(dojo.byId(this._WID+indicatorId)).x;
		var indicatorY = dojo._abs(dojo.byId(this._WID+indicatorId)).y;
		var relativeX = indicatorX - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).x + this.colorPickerAdjustPosX;
		var relativeY = indicatorY - dojo._abs(dojo.byId(this._iContext.widgetId+"_edit")).y + this.colorPickerAdjustPosY;
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._showColorPalette(this._WID,this._WID+indicatorId,this._WID+colorDivId,relativeX,relativeY);			
	},	
			
	/**
	 * init the starting column size according to the number of column
	 * @param {number} colNum
	 */
	initWidthOfColumn:function(colNum){
		this.widthOfColumn = {};
		if (colNum != com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum()){
			var wholeWidth = 1050;//1070 - 10*2
			var largeNum = 1050 % colNum;
			var smallWidth = 1050 / colNum | 0;
			var largeWidth = smallWidth + 1 ;
			for(var i = 1 ; i <= largeNum; i++){
				this.widthOfColumn[i+""] = largeWidth + "px";
			}
			for(var j = largeNum +1  ;j <= colNum ; j++){
				this.widthOfColumn[j+""] = smallWidth + "px";
			}			
		}else{
			for(var i=1;i<=colNum;i++){ // JSLINT-IGNORE:
				//this.widthOfColumn[i+""] = dojo.byId(this._WID+"Column"+i).style.width;
				this._setRelativePercentageForColumn(i, dojo.marginBox(dojo.byId(this._WID+"Column"+i)).w);
			}
		}	
	},
	
	/**
	 * init the starting column size according to the number of column
	 * @param {number} colNum
	 */
	resetWidthOfColumn:function(){
		this.widthOfColumn = {};
		var curColNum = com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum();
		var widthObj = com.ibm.mm.builder.columnLayoutBean.getColumnsJSONObject().widths;	
		var num = parseInt(curColNum,10);
		for (var x=1;x<num + 1;x++){
			this.widthOfColumn[x+""] = widthObj[x+""];
		}
		return this.widthOfColumn;
	},	
		
	refreshColumnWidth:function(){
		var colNumber = com.ibm.mm.builder.columnLayoutBean.getCurrentColumnNum();
		for(var i=1;i<=colNumber;i++){
			this._setRelativePercentageForColumn(i, dojo.style(dojo.byId(this._WID+"Column"+i), "width"));
		}	
	},
	
	changeColumn:function(){
		var selection = dojo.byId(this._WID + "columnConfigTargetSelection").value;
		var num = dojo.byId(this._WID + "columnNumberSelection").value;
		for (var i=1;i<=num;i++){
			dojo.byId(this._WID + "eachColumnBgColorIndicator" + i + "_checkBox").style.display = "none";
			dojo.byId(this._WID + "eachColumnBgColorIndicator" + i).style.display = "none";		
			dojo.byId(this._WID + "columnBorderSelection" + i).style.display = "none";	
			dojo.byId(this._WID + "columnBorderColorIndicator" + i).style.display = "none";	
		}
		dojo.byId(this._WID + "eachColumnBgColorIndicator"+selection+"_checkBox").style.display = "";
		dojo.byId(this._WID + "eachColumnBgColorIndicator"+selection).style.display = "";
		dojo.byId(this._WID + "columnBorderSelection"+selection).style.display = "";
		dojo.byId(this._WID + "columnBorderColorIndicator"+selection).style.display = "";
				
	},
		
	_createOption:function(position){
		var option = document.createElement("option");
		option.id = this._WID + "text2_"+position;
		option.text = dojo.eval("com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_OPTIONS_FOR_NUMBER_"+position); // JSLINT-IGNORE:
		option.value = position;
		return option;
	},
	
	changeColumnNumber:function(columnAttrJSONObj){
		var selection = parseInt(dojo.byId(this._WID + "columnNumberSelection").value,10);
		var columnLength = dojo.byId(this._WID + "columnConfigTargetSelection").length;
		if (!columnAttrJSONObj){
			columnAttrJSONObj = com.ibm.mm.builder.columnLayoutBean.getColumnAttrJSONObject();
		}
		var clonedObj = {};
		clonedObj = dojo.clone(columnAttrJSONObj);
		var defaultSetting = com.ibm.mm.builder.columnLayoutBean.getColDefaultSetting();		
		if(selection < columnLength){
			for( var i = columnLength; i >= selection; i--){
				dojo.byId(this._WID + "columnConfigTargetSelection").remove(i);
			}
		}else{
			for( var i = columnLength + 1; i <= selection; i++ ){ // JSLINT-IGNORE:
				var option = this._createOption(i);
				if(dojo.isIE){
					dojo.byId(this._WID + "columnConfigTargetSelection").add(option);
				}else{
					dojo.byId(this._WID + "columnConfigTargetSelection").add(option,null);
				}	
			}
		}
		for( var i = 1; i <= selection; i++){ // JSLINT-IGNORE:
			clonedObj[i] = com.ibm.mm.builder.columnLayoutBean.getSingleColumnDefaultSetting();		
		}		
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnSetting(this._iContext,selection,clonedObj);
		this.changeColumn();
		dojo.byId(this._WID + "columnConfigTargetSelection").options[0].selected  = true;
	},
	
	initTheColumnNumber:function(columnAttrJSONObj){
		var selection = parseInt(dojo.byId(this._WID + "columnNumberSelection").value,10);
		var columnLength = dojo.byId(this._WID + "columnConfigTargetSelection").length;
		if (!columnAttrJSONObj){
			columnAttrJSONObj = com.ibm.mm.builder.columnLayoutBean.getColumnAttrJSONObject();
		}
		var defaultSetting = com.ibm.mm.builder.columnLayoutBean.getColDefaultSetting();	
		var i = 0;	
		if(selection < columnLength){
			for( i = columnLength; i >= selection; i--){
				dojo.byId(this._WID + "columnConfigTargetSelection").remove(i);
			}
		}else{
			for( i = columnLength + 1; i <= selection; i++ ){
				var option = this._createOption(i);
				if(dojo.isIE){
					dojo.byId(this._WID + "columnConfigTargetSelection").add(option);
				}else{
					dojo.byId(this._WID + "columnConfigTargetSelection").add(option,null);
				}	
			}
		}	
		com.ibm.mm.builder.iwidget.columnlayout.columnUtil._createEachColumnSetting(this._iContext,selection,columnAttrJSONObj);
		this.changeColumn();
		dojo.byId(this._WID + "columnConfigTargetSelection").options[0].selected  = true;		
	},
	
	showConfigurationIcon:function(){
		if (this.currentPageMode != "edit") {
			return;
		} 
		clearTimeout(this.showConfigurationIconTimer);
		this.showConfigurationIconTimer = window.setTimeout(dojo.hitch(this, function(){
			dojo.style(this._WID + "configIcon", "display", "");
		}),40);
	},

	hideConfigurationIcon:function(){
		clearTimeout(this.hideConfigurationIconTimer);
		this.hideConfigurationIconTimer = window.setTimeout(dojo.hitch(this, function(){
			dojo.style(this._WID + "configIcon", "display", "none");
		}),40);
	},
	
	fillInTheText:function(){
		dojo.parser.parse(this.columnEditPane.domNode);
		this.setG11nString("pageproperties_text","I_COLUMN_CONF_PAGE_PROPERTIES");
		
		this.setG11nString("pagebgimage_text","I_COLUMN_CONF_PAGE_BACKGROUND_IMAGE");
		this.setG11nString("URLRequired_text","I_COLUMN_CONF_PAGE_BG_URL_REQUIRED");
		this.setG11nString("imageproperties_text","I_COLUMN_CONF_PAGE_BG_IMAGE_PROPERTIES");
		this.setG11nString("repeathorizontalcolumn_text","I_COLUMN_CONF_PAGE_BG_IMAGE_PROP_REPEATH");
		this.setG11nString("repeatverticalcolumn_text","I_COLUMN_CONF_PAGE_BG_IMAGE_PROP_REPEATV");
		this.setG11nString("repeatbothcolumn_text","I_COLUMN_CONF_PAGE_BG_IMAGE_PRO_REPEATB");
		this.setG11nString("centercolumn_text","I_COLUMN_CONF_PAGE_BG_IMAGE_PROP_CENTER");
		this.setG11nString("pagePropertiesMore","I_COLUMN_CONF_MORE");
		dojo.byId(this._WID + "pagePropertiesMore").title = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MORE;
		this.setG11nString("pagebordercolumn_text","I_COLUMN_CONF_PAGE_BORDER");
		this.setG11nString("pagemargincolumn_text","I_COLUMN_CONF_PAGE_MARGIN");
		this.setG11nString("applyAllUsingDS_text","I_COLUMN_CONF_WIDGET_APPLY_SKIN");
		this.setG11nString("applyAllWigets_text","I_COLUMN_CONF_WIDGET_APPLY_SKIN_ALL");
		this.setG11nString("applyToAllWidgets_text","I_COLUMN_CONF_WIDGET_APPLY_TOWIDGETS");
		
		this.setG11nString("columnproperties_text","I_COLUMN_CONF_COLUMN_PROPERTIES");
		
		this.setG11nString("text1_1","I_COLUMN_CONF_COLUMN_NUMBER_1");
		this.setG11nString("text1_2","I_COLUMN_CONF_COLUMN_NUMBER_2");
		this.setG11nString("text1_3","I_COLUMN_CONF_COLUMN_NUMBER_3");
		this.setG11nString("text1_4","I_COLUMN_CONF_COLUMN_NUMBER_4");
		
		this.setG11nString("widBetweenColsSlider_label","I_COLUMN_CONF_WIDTH_BETWEEN_COLUMN");
		this.setG11nString("numberofcolumns_text","I_COLUMN_CONF_COLUMN_NUMBER");
		this.setG11nString("colPropertiesMore","I_COLUMN_CONF_MORE");
		dojo.byId(this._WID + "colPropertiesMore").title = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MORE;
		this.setG11nString("allcolumn_text","I_COLUMN_CONF_ALLCOLUMN_FOR");
		this.setG11nString("individualcolumn_text","I_COLUMN_CONF_INDIVIDUALCOL_FOR");
		
		this.setG11nString("text2_1","I_COLUMN_CONF_OPTIONS_FOR_NUMBER_1");
		
		if(dojo.byId(this._WID + "text2_2")){
			this.setG11nString("text2_2","I_COLUMN_CONF_OPTIONS_FOR_NUMBER_2");
		}
		if(dojo.byId(this._WID + "text2_3")){
			this.setG11nString("text2_3","I_COLUMN_CONF_OPTIONS_FOR_NUMBER_3");
		}
		if(dojo.byId(this._WID + "text2_4")){
			this.setG11nString("text2_4","I_COLUMN_CONF_OPTIONS_FOR_NUMBER_4");
		}
		
		this.setG11nString("bgcolor_text","I_COLUMN_CONF_COLUMN_PROP_BG_COLOR");
		this.setG11nString("bgcolor_text1","I_COLUMN_CONF_COLUMN_PROP_BG_COLOR");
		this.setG11nString("border_text","I_COLUMN_CONF_COLUMN_PROP_BORDER");
		this.setG11nString("border_text1","I_COLUMN_CONF_COLUMN_PROP_BORDER");
		this.setG11nString("widgetpro_text","I_COLUMN_CONF_WIDGET_PROPERTIES");
		this.setG11nString("defskinfornewwidget_text","I_FREEFORM_CONF_WIDGET_DEFAULT_SKIN");
		this.setG11nString("widgetPropertiesMore","I_COLUMN_CONF_MORE");
		dojo.byId(this._WID + "widgetPropertiesMore").title = com.ibm.mm.builder.coreWidgetsStrings.I_COLUMN_CONF_MORE;
		this.setG11nString("vMarginSlider_label","I_COLUMN_CONF_WIDGET_PROP_VMARGINS");
		this.setG11nString("hMarginSlider_label","I_COLUMN_CONF_WIDGET_PROP_HMARGINS");
		this.setG11nString("url_text","I_COLUMN_CONF_PAGE_BG_URL");
		var widthLimit = dojo.isIE ? "60" : "140";
		this.setG11nString("restoredef_text1","I_COLUMN_CONF_RESTORE_BUTTON");
		dojo.attr(dojo.byId(this._WID+"restoredef_text1"),"widthLimit",widthLimit);
		this.setG11nString("restoredef_text2","I_COLUMN_CONF_RESTORE_BUTTON");
		dojo.attr(dojo.byId(this._WID+"restoredef_text2"),"widthLimit",widthLimit);
		this.setG11nString("restoredef_text3","I_COLUMN_CONF_RESTORE_BUTTON");
		dojo.attr(dojo.byId(this._WID+"restoredef_text3"),"widthLimit",widthLimit);
		this.setG11nString("bgcolorofpage_text1","I_COLUMN_CONF_PAGE_BACKGROUND_COLOR");
		this.setG11nString("pageBgImageNone_text1","I_COLUMN_CONF_PAGE_BG_NONE");
		
		this._setA11YHint("restoredef_text3", "I_COLUMN_CONF_RESTORE_DEFAULT_PAGE_PROPERTIES");
		this._setA11YHint("restoredef_text2", "I_COLUMN_CONF_RESTORE_DEFAULT_COLUMN_PROPERTIES");
		this._setA11YHint("restoredef_text1", "I_COLUMN_CONF_RESTORE_DEFAULT_WIDGET_PROPERTIES");
		
		
		// border style
		var borderSelect = dojo.byId(this._WID + "pageBorderSelection");
		com.ibm.mm.builder.utils.layoutUtil.setBorderSelect(borderSelect);
		var borderSelect3 = dojo.byId(this._WID + "allColumnBorderSelection");
		com.ibm.mm.builder.utils.layoutUtil.setBorderSelect(borderSelect3);	
		
		com.ibm.mm.builder.utils.htmlUtil.truncateAllChildNodesText(dojo.byId(this._WID+this.currentPageMode));
	},
	
	_setA11YHint: function(idSuffix, stringVarName){
		var node = dojo.byId(this._WID + idSuffix);
		dojo.attr(node, "title", com.ibm.mm.builder.coreWidgetsStrings[stringVarName]);
		
	},
	
	setG11nString:function(idSuffix,stringVarName){
		var node = dojo.byId(this._WID + idSuffix);
		var textField = (node.tagName.toLowerCase() === "input") ? "value" : "innerHTML";
		node[textField] = com.ibm.mm.builder.coreWidgetsStrings[stringVarName];
	},
	
    _calculateRelativePercentage : function(width, index) {  
	    var containerWidth = dojo._getContentBox(dojo.byId(this._WID+"container")).w;
		return (width * 100 / containerWidth) + "%";
	},
 
    _setColumnWidth : function(index, width) {
	  var column = dojo.byId(this._WID+"Column"+index); 
	  var oldBox = dojo.marginBox(column);
	  var widthToSet = parseInt(width,10);
	  dojo.marginBox(column, {w : widthToSet});
	},
	
	_getColumnMarginExtent : function(index) {
	  var column = dojo.byId(this._WID+"Column"+index);
	  return dojo.marginBox(column).w - parseInt(dojo.style(column, "width"),10);
	},

    _setColumnPercentageUsingAbsWidth : function(index, width) {
	  if (width < 0) {
	     return ;
	  }
	  width = width + this._getColumnMarginExtent(index);
	  this._setRelativePercentageForColumn(index, width);
	  this._setColumnWidth(index, width + "px");
	  //this._setColumnWidth(index, this._calculateRelativePercentage(width, index));
	},
	
	_setColumnWidthUsingPercentage : function(index, percentage) {
		var width = this._getAvailableWidthForColumns();
		var round = dojo.isIE != 6 ? 2 : 12; //Use this value to work around the precision problem with float operation
		this._setColumnWidth(index, (Math.floor(width * percentage) - round) + "px");
	},
	
	_resetColumnWidth : function(index) {
		this._setColumnWidthUsingPercentage(index, this._getRelativePercentageForColumn(index));
	
	    this._notifyColumnResized(index);
	},
	
	_notifyColumnResized : function(columnIndex) {
        var widgetResized = function(widget){
            var widgetBox = dojo.contentBox(widget.id + "_content");
            var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
            var payload = {"newWidth": widgetBox.w,"newHeight": widgetBox.h};
            eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET+"."+widget.id,payload);
        } ;
        var columnId = this._WID + "Column" + columnIndex;
        dojo.query(".iWidgetSkin[skin]", dojo.byId(columnId)).forEach(widgetResized);
    },
	
	_calculateRelativePercentage : function(width) {  // JSLINT-IGNORE:
		var total = this._getAvailableWidthForColumns();
		return width / total;
	},
	
	_adjustContainerWidth : function() {
		var containerWidth = null;
		var pageContainer = dojo.byId(this._WID+"container");
		if (dojo.isIE != 6) {
			var viewRootNode = pageContainer.parentNode;
			containerWidth = dojo.contentBox(viewRootNode).w;
		}
		else {
			//Here is the IE 6 hack
			containerWidth = dojo.style(dojo.body(), "width");
		}
		dojo.marginBox(pageContainer, {w : containerWidth});
	},

	_resizeColumns : function() {
		if (dojo.isIE != 6) {
			this._adjustContainerWidth();
		}
		
		if (this.layoutObject.pageId) { //resize the columns only when the page exists
			var columnNum = this._getColumnNumber();
			for (var i = 1; i <= columnNum; i++) {
				this._resetColumnWidth(i);
			}
		}
	},
	
	_getColumnNumber : function() {
		return parseInt(com.ibm.mm.builder.columnLayoutBean.getColumnsJSONObject().columnNumber,10);
	},
	
	_getAvailableWidthForColumns : function() {
		var containerWidth = dojo._getContentBox(dojo.byId(this._WID+"container")).w;
		var marginLeft = 10;
		var marginRight = 10;
		var columnNum = this._getColumnNumber();
		var sizerWidth = 0;
		for (var i = 1; i < columnNum; i++) {
			sizerWidth += dojo.style(dojo.byId(this._WID + "Sizer" + i), "width");
		}
		return containerWidth - sizerWidth;
	},
	
	_getRelativePercentageForColumn : function(index) {
		var w = this.widthOfColumn[index + ""];
		if (dojo.isString(w)) {
			if (w.indexOf("px") != -1) {
				return this._calculateRelativePercentage(parseFloat(w));
			}
			else if (w.indexOf("%") != -1) {
				return parseFloat(w) / 100.0;
			}
		}
		else {
			return w;
		}
	},
	
	_setRelativePercentageForColumn : function(index, width) {
		var percentage = this._calculateRelativePercentage(width);
		this.widthOfColumn[index + ""] = percentage;
	}
});				

}
