if(!dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WiringModel");
dojo.require("com.ibm.mm.builder.iwidget.wiringscreen.WiringItem");
dojo.require("com.ibm.mm.builder.widget.CustomDialog");


/**
 * The WiringCanvas widget. it use the wiring model to render the overview graph in a dialog
 */
dojo.declare("com.ibm.mm.builder.iwidget.wiringscreen.WiringCanvas", [dijit._Widget, dijit._Templated], {

    templateString: "<div class='wiringcanvas'>" +
						"<div DojoAttachPoint='graphContainer' class='graphcontainer'>" +
						"</div>" +
					"</div>",
					
	alone:true,
	diagramNode: null,
    
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	
	constructor: function(params){
		//all widget thumb in the canvas
	   	this.itemList = [];
		//the thumb of iwidget already drawed on canvas
	    this.finishedWidgetList = [];
	    this.finishedLinkList = [];
		this.widgetItemQueue = [];
		
        //the default size of thumb and the arrow link 
		this.bgWidth = 82;
		this.itemWidth = 92;
		this.gridHorizontalInterval = 120;
        this.bgHeight = 54;
        this.gridHeight = 2 * this.bgHeight;
        this.gridWidth = this.itemWidth + this.gridHorizontalInterval;
        this.arrowWidth = 12;
        this.arrowHeight = 10;
		
		this.canvasMargin = 0;
		
		this.minCanvasWidth = 420 ;
		this.minCanvasHeight = 100 ;
		this.maxDialogHeight = 5 * this.gridHeight + 10;
		this.lineCornerRadius = 4;
		
		this.dialogSideBarWidth = 0;
		this.dialogBackgroundColor = "#1f1f1f";
		this.dialogTopAndBottom = 20/*bottom height*/ + 36/*top height*/ + 2/*dialog border*/ + 2;
        
		this.explainText = "";
    },
	
	postCreate: function(){
		this.createDialog();
	},
	
	/**
	 * create and show the wiring graph
	 */
	showGraph:function(){
		this.showLoading();
	    this.createModel();
		dojo["require"]("dojox.gfx"); // JSLINT-IGNORE: needed here, if not loaded in layer
		this.hideLoading();
		this.createGraph();
	},
	
    /**
	 * Create the dialog contains the wiring graph
	 */
    createDialog: function(){
		this.wiringDialog = new com.ibm.mm.builder.widget.CleanDialog({
			id: this.selectedWidgetId + "_wireGraph",
			nodeWidth: null,  // the content node width, not the dialog, so you can focus on your own node
			nodeHeight: null,    // the content node width, null for autofix
			title: this.cws.I_WIRINGGRAPH_TITLE,
			containerBackgroundColor: null,   // the background color of the container
			displayCloseButton: true,    
			modelDialog:this.alone,
			hasRightBottomResizer: false,
			leftBarWidth: this.dialogSideBarWidth + "px",
			rightBarWidth: this.dialogSideBarWidth + "px",
			containerNodePadding: "0px",
			bottomBarTipColor: "#ff9a9a",
			closeCallback: dojo.hitch(this, function(){
				this.destroy();
			})
        });
		this.wiringDialog.containerNode.appendChild(this.domNode);
		if(!this.alone) {
			var wirePaneDlg = dijit.byId("wireInterface_uniDialog");
			if (wirePaneDlg) {
				wirePaneDlg.registerSubDialog(this.selectedWidgetId + "_wireGraph");
			}
		}
    },
	/**
	 * Show a loading tips when computing the diagram
	 */
	showLoading: function(){
		this.loadingNode = document.createElement("div");
		var imgPath = builderConfig.builderPath + "/images/loading.gif";
		this.loadingNode.innerHTML = "<img border='0' src='" + imgPath + "'/>" +
			"<span style='font-size:1.3em;color:white'>" + this.I_WIRINGGRAPH_LOADING_MESSAGE + "</span>";
		
		this.wiringDialog.domNode.style.width = this.minCanvasWidth + "px";
		
		this.graphContainer.appendChild(this.loadingNode);
		this.show();
	},
	/**
	 * Hide the loading tips when computing the diagram
	 */
	hideLoading: function(){
		this.graphContainer.removeChild(this.loadingNode);
	},
    
	/**
	 * create the model of the wiring graph
	 */
    createModel: function(){
        this.parentWiringModel = new com.ibm.mm.builder.iwidget.wiringscreen.WiringModel(this.selectedWidgetId);
		//Initialize the whole model of all widget
        this.parentWiringModel.setupWiringModel();
		//Create the model from the selected widget
        this.wiringModel = this.parentWiringModel.getSelectedModelFrom(this.selectedWidgetId);
    },
    
	/**
	 * create the the wiring graph and show it
	 */
    createGraph: function(){
		this.wiringDialog.setNodeWidth(this.getCanvasWidth() + "px");
		
		this.wiringDialog.show();
		
		// #14393, IE failed if the vml node created before the dialog shown up.
		window.setTimeout(dojo.hitch(this, function() {
			//set up the canvas for drawing graph
			this._setupCanvas();
	        
			//get root from the selected widget
	        var roots = this.wiringModel.getRootFrom(this.selectedWidgetId);
	        
			//loop to make all link in the tree added to the canvas
	        for (var i = 0, length = roots.length; i < length; i++) {
				this.widgetItemQueue.push(roots[i]);
	        }
			this._drawLinks();
			
			// set the info tip at the bottom
			if (this.wiringModel.hasLink()) {
				this._setupBottomTips();
				this.diagramExplainTextNode.innerHTML = this.explainText;
				dojo.attr(this.diagramNode, "title", this.explainText);
			} else {
				var msg = this.cws.I_WIRINGGRAPH_NO_WIRING ? this.cws.I_WIRINGGRAPH_NO_WIRING : "No wiring connected";
				this.diagramExplainTextNode.innerHTML = msg;
				dojo.attr(this.diagramNode, "title", msg);
			}
		}), 700);
	},
	
	/**
	 * set the help information
	 */
	_setupBottomTips: function(){
		var selectedWidget =  this._getWidget({"id":this.selectedWidgetId});
		var widgetName = com.ibm.mm.builder.utils.iwidgetUtil.formatWidgetTitle(selectedWidget.title);
		
		var widgetNameForTip = "<span style='font-style:italic'>" + widgetName + "</span>";
		var bottomTip = dojo.string.substitute(this.cws.I_WIRINGGRAPH_BOTTOM_MESSAGE_BEFORE, [widgetNameForTip]);
		//this.wiringDialog.setBottomTip(bottomTip);
		com.ibm.mm.builder.utils.htmlUtil.setClass(this.diagramTip, "wiringgrpahbottomtip");
		this.diagramTip.innerHTML = bottomTip;
		
		//this.wiringDialog.setBottomTipColor("#ff9a9a");
	},
	
	/**
	 * initialize the canvas for drawing the wiring overview graph
	 */
	_setupCanvas: function(){
        var canvasWidth = this.getCanvasWidth();
        var canvasHeight = this.getCanvasHeight();
        
		// setup the diagram node
        this.diagramNode = document.createElement("div");
		dojo.attr(this.diagramNode,"tabindex","0");
        this.diagramExplainTextNode = document.createElement("span");
        this.diagramTip = document.createElement("div");
		
		this.domNode.style.width = canvasWidth + "px";
		//this.domNode.style.height = canvasHeight + "px";
		
		com.ibm.mm.builder.utils.htmlUtil.setClass(this.diagramNode, "diagramnode");
		com.ibm.mm.builder.utils.htmlUtil.setClass(this.diagramExplainTextNode, "diagramExplainTextNode");
		
		//must append on domNode before create surface, or will raise error on IE
		this.graphContainer.appendChild(this.diagramExplainTextNode);
		this.graphContainer.appendChild(this.diagramNode);
		this.graphContainer.appendChild(this.diagramTip);
		
        this.surface = dojox.gfx.createSurface(this.diagramNode, canvasWidth, this._getSurfaceHeight());
    },	
	
    /**
	 * show the wiring graph dialog and set the backgound dark.
	 */
    show: function(){
        this.wiringDialog.show();
    },
    
	/**
	 * draw all the links
	 */
	_drawLinks: function(){
		var tmpItem = this.widgetItemQueue.splice(0,1)[0];
		this._drawLinksFrom(tmpItem);
	},
	/**
	 * Draw the graph from root
	 * @param {Object} source The root node
	 */
    _drawLinksFrom: function(source){
		if (!source) {
			return;
		}
		//for 20752. A source can appear in widgetItemQueue multiple times depending how many events it wires to another widget. 
		//It appears that once a source is processed, it's removed from the queue. What left in there are those need to be processed.
        //if (!this._isFinishedWidget(source.id)) { 
            var children = this.wiringModel.getChildren(source.id);
            //first create the source widget in case it not exit.
			this._getWidgetDomNode(source);
			
			//find all the children of the source and create the link on the canvas 
			for (var i = 0, length = children.length; i < length; i++) {
				var target = children[i];
				if (target) {
					this._createLink(source, target);
				}
			}
			//mark this widget as finished
			this.finishedWidgetList.push(source.id);
			
			//recursion to the chldren of the source
			for (var j = 0, jlength = children.length; j < jlength; j++) {
				if (children[j]) {
					this.widgetItemQueue.push(children[j]);
				}
			}
			this._drawLinksFrom(this.widgetItemQueue.splice(0,1)[0]);
       // }
    },
    
	/**
	 * Check weather the widget is already created in the graph
	 * @param {number} id The id of the widget
	 */
    _isFinishedWidget: function(id){
        for (var i = 0, length = this.finishedWidgetList.length; i < length; i++) {
            if (this.finishedWidgetList[i] == id) {
				return true;
			}
        }
        return false;
    },
	
	/**
	 * Check weather the link from srouce to target is already created in the graph
	 * @param {number} sourceId The id of the source widget
	 * @param {number} targetId The id of the target widget
	 */
    _isFinishedLink: function(sourceId,targetId){
        for (var i = 0, length = this.finishedLinkList.length; i < length; i++) {
            if (this.finishedLinkList[i].source == sourceId && this.finishedLinkList[i].target == targetId) {
				return true;
			}
        }
        return false;
    },
	
	/**
	 * create link between widgets
	 * @param {Object} source The source widget
	 * @param {Object} target The target widget
	 */
    _createLink: function(source, target){
		if (this._isRelateToSelectedWidget(source, target)) {
			if (this._isFinishedLink(target.id, source.id)) {
				this._createBackArrow(target);
			}
			else {
				this._createForwardLink(source, target);
			}
			this._generateExplainText(source, target);
		}
    },
	
	_generateExplainText: function(source, target){
		this.explainText += dojo.string.substitute(this.cws.I_WIRINGGRAPH_LINK_EXPLAIN_TEXT, [source.title, target.title]);
	},
	
	_isRelateToSelectedWidget:function(source, target){
		if (source.id == this.selectedWidgetId || target.id == this.selectedWidgetId) {
			return true;
		}
		return false;
	},
	/**
	 * Create a back arrow on exsit link
	 * @param {Object} target The id of the target widget
	 */
	_createBackArrow: function(target){
		var targetWidgetNode = this._getWidgetDomNode(target);
		var arrowPoint = this._getBackArrowPoint(targetWidgetNode);
        //create the arrow on the surface
		var image = this._createImage(builderConfig.builderPath + (!builderConfig.isBidi) ? "/images/arow_head_left.gif" : "/images/arow_head_left.gif", 
			this.arrowWidth,
			this.arrowHeight
		);
		//move the image of arrow to the right place
        image.setTransform(dojox.gfx.matrix.translate(arrowPoint.x, arrowPoint.y));
	},
	
	_createImage : function(src, width, height) {
		var image = this.surface.createImage({
            width: width,
            height: height,
            src: src
        });
		if (dojo.isSafari != 4) {
			return image;
		}
		else {
			var group = this.surface.createGroup();
			group.add(image);
			return image;
		}
	},
	
	/**
	 * Create forword link
	 * @param {Object} source The id of the source widget
	 * @param {Object} target The id of the target widget
	 */
	_createForwardLink: function(source, target){
		//get the model and create the related widget		
        var sourceWidgetNode = this._getWidgetDomNode(source);
        var targetWidgetNode = this._getWidgetDomNode(target);
		
		//if source is not finished and hasLoop(source, target) draw a loop
		
		//else // a normal link
        //caculate the place
        var startPoint = this._getStartPoint(sourceWidgetNode);
        var endPoint = this._getEndPoint(targetWidgetNode);
        var middlePoints = this._getMiddlePoints(startPoint, endPoint);
		var lineStyle = {
            color: [255, 255, 255],
            width: 2,
            dashstyle: "solid"
        };

		//the start line
		var startX = (!builderConfig.isBidi)?(middlePoints[0].x - this.lineCornerRadius):(middlePoints[0].x + this.lineCornerRadius);
		var path = "M" + startPoint.x + " " + startPoint.y + //start point
        " L" +
        //(middlePoints[0].x - this.lineCornerRadius) +
		(startX) +
        " " +
        middlePoints[0].y; //end point
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the first round corner
		//path = "M" + (middlePoints[0].x - this.lineCornerRadius) + " " + middlePoints[0].y +//start point
		path = "M" + (startX) + " " + middlePoints[0].y +
        " S" + 
		 middlePoints[0].x +
        " " +
        middlePoints[0].y +
        " " +
		middlePoints[0].x +
        " " +
        this._getFirstCornerStartY(middlePoints);//end point
		
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the vertical line
		path = "M" + (middlePoints[0].x) + " " + this._getFirstCornerStartY(middlePoints) +//start point
        " L" +
        middlePoints[1].x +
        " " +
        this._getSecondCornerStartY(middlePoints);//end point
		
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the second round corner

		var endX = (!builderConfig.isBidi)?(middlePoints[1].x + this.lineCornerRadius):(middlePoints[1].x - this.lineCornerRadius);
		path = "M" + middlePoints[1].x + " " + this._getSecondCornerStartY(middlePoints) +//start point
        " S" + 
		 middlePoints[1].x +
        " " +
        middlePoints[1].y +
        " " +
		//(middlePoints[1].x + this.lineCornerRadius) +
		endX +
        " " +
        middlePoints[1].y ; 
		
		this.surface.createPath(path).setStroke(lineStyle);
		
		//the end line
		//path = "M" + (middlePoints[1].x + this.lineCornerRadius) + " " + middlePoints[1].y  +//start point
		path = "M" + (endX) + " " + middlePoints[1].y  +//start point
        " L" +
        endPoint.x +
        " " +
        endPoint.y; //end point
        
		this.surface.createPath(path).setStroke(lineStyle);
        var arrowPoint = this._getArrowPoint(endPoint);
        //create the arrow on the surface
		var arrowHead = (!builderConfig.isBidi) ? "/images/arow_head.gif" : "/images/arow_head_left.gif";
		var image = this._createImage(builderConfig.builderPath + arrowHead,
			this.arrowWidth,
			this.arrowHeight
		);
		//move the image of arrow to the right place
		// #11717 No need to hack IE6 from 2.0
		//if((dojo.isIE === 6 ) && builderConfig.isBidi){
        //	image.setTransform(dojox.gfx.matrix.translate(arrowPoint.x - this.getCanvasWidth(), arrowPoint.y));
		//}else{
        	image.setTransform(dojox.gfx.matrix.translate(arrowPoint.x, arrowPoint.y));
		//}
		this.finishedLinkList.push({"source":source.id,"target":target.id});
	},
    
	/**
	 * get the Y of end point in the first coner(that is the start point of the vertical line) 
	 * @param {Object} middlePoints
	 */
	_getFirstCornerStartY : function(middlePoints){
		var y = middlePoints[0].y;
		if(middlePoints[0].y < middlePoints[1].y){
			return y + this.lineCornerRadius;
		}else if(middlePoints[0].y > middlePoints[1].y){
			return y - this.lineCornerRadius; 
		}else{
			return y;
		}
	},
	
	/**
	 * get the Y of end point in the second coner(that is the end point of the vertical line) 
	 * @param {Object} middlePoints
	 */
	_getSecondCornerStartY : function(middlePoints){
		var y = middlePoints[1].y;
		if(middlePoints[0].y < middlePoints[1].y){
			return y - this.lineCornerRadius;
		}else if(middlePoints[0].y > middlePoints[1].y){
			return y + this.lineCornerRadius; 
		}else{
			return y;
		}
	},
    
	/**
	 * Create or get(if already exsit) the item(as domNode) of the widget
	 * @param {Object} itemInfo The infomation of the widget
	 */
    _getWidgetDomNode: function(itemInfo){
		return this._getWidget(itemInfo).domNode;
    },
	
	/**
	 * Create or get(if already exsit) the item's image dom node of the widget
	 * @param {Object} itemInfo The infomation of the widget
	 */
	 _getWidgetImageNode: function(itemInfo){
		return this._getWidget(itemInfo).getImageNode();
    },
    
	/**
	 * Create or get(if already exsit) the item(as a widget) of the widget
	 * @param {Object} itemInfo The infomation of the widget
	 */
	_getWidget : function(itemInfo){
		//if has already been created, just return 
        for (var i = 0, length = this.itemList.length; i < length; i++) {
            if (this.itemList[i].id == itemInfo.id) {
				return this.itemList[i].itemWidget;
			}
        }
		
		//if not created yet, create it
        var widgetNode;
		
		var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetTitleCSA2(itemInfo.id);
		var widgetIcon = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetIconCSA2(itemInfo.id);
		dojo.mixin(itemInfo, {
			"isSelected": (itemInfo.id == this.selectedWidgetId),
			"title": widgetTitle, "icon": widgetIcon});
		var item = new com.ibm.mm.builder.iwidget.wiringscreen.WiringItem(itemInfo);
        
		//set the layout variable
        var marginLeft = (this.wiringModel.size.x * this.gridWidth <= this.minCanvasWidth + 80)? 60: 20;
        var marginTop = 20;
        var marginLeftForOne = (this.minCanvasWidth- 100)/2;
        var marginTopForOne = 20;
        var gridWidth = this.gridWidth;
        var gridHeight = this.gridHeight;
		var itemWidth = this.itemWidth;
        
        widgetNode = item.domNode;
		var x = null;
		var y = null;
		if(!this.wiringModel.hasLink()){
			if(builderConfig.isBidi){
				x = this.getCanvasWidth() - (itemInfo.position.x * gridWidth + marginLeftForOne) - itemWidth + "px";
			}else{
				x = (itemInfo.position.x * gridWidth + marginLeftForOne) + "px";
			}
			y = ((itemInfo.position.y-1) * gridHeight + marginTopForOne) + "px";
			this._setWidgetPositionAndAdd(widgetNode, x, y);
		} else if (this.wiringModel.levelHeight[itemInfo.position.x] == this.wiringModel.size.y) {
			//if the wiring model has no link relationship or the height of this level is the size of the model
			//draw the widget according to the original place
			if(builderConfig.isBidi){
				x = this.getCanvasWidth() - (itemInfo.position.x * gridWidth + marginLeft) - itemWidth + "px";
			}else{
				x = (itemInfo.position.x * gridWidth + marginLeft) + "px";	
			}
			y = ((itemInfo.position.y-1) * gridHeight + marginTop) + "px";
			this._setWidgetPositionAndAdd(widgetNode, x, y);

		}
		else {
			//if the height of this level is not the size of model, compute the height of the grid height
			var interGridHight = ((this.wiringModel.size.y - 1) / this.wiringModel.levelHeight[itemInfo.position.x]) * gridHeight;
			var extendMarginTop = interGridHight / 2;
			if (builderConfig.isBidi) {
				x = this.getCanvasWidth() - (itemInfo.position.x * gridWidth + marginLeft) - itemWidth + "px";
			}else {
				x = (itemInfo.position.x * gridWidth + marginLeft) + "px";
			}
			y = ((itemInfo.position.y - 1) * interGridHight + marginTop + extendMarginTop) + "px";
			
			this._setWidgetPositionAndAdd(widgetNode, x, y);
		}
        
		//add the widget to the itemList
        this.itemList.push({
            id: itemInfo.id,
            itemWidgetNode: widgetNode,
            itemWidget: item
        });
        return item;
	},
	
	/**
	 * Create a Highlight div node for the selected widget
	 * @param {Widget} item A wiring item
	 */
    _createHighlightDiv: function(item){
        var highlightDiv = document.createElement("div");
        com.ibm.mm.builder.utils.htmlUtil.setClass(highlightDiv, "hightlightwiringgraphitem");
        highlightDiv.appendChild(item.domNode);
        return highlightDiv;
    },
    
	/**
	 * get the start point of a link
	 * @param {DomNode} node The node of the start item of a link
	 */
    _getStartPoint: function(node){
		//compute the x and y coordinate of the start posion 
		var coords = dojo.coords(node);
        var px = coords.l + this.itemWidth - (this.itemWidth-this.bgWidth)/2;
		if (builderConfig.isBidi) {
			px = px - this.itemWidth;		
		}
				
        var py = coords.t + this.bgHeight / 2;
        return {
            x: px,
            y: py
        };
    },
    
	/**
	 * get the end point of a link
	 * @param {DomNode} node The node of the end item of a link
	 */
    _getEndPoint: function(node){
		//compute the x and y coordinate of the end posion
		var coords = dojo.coords(node);
        var px = coords.l - this.arrowWidth + (this.itemWidth-this.bgWidth)/2;
		if (builderConfig.isBidi) {
			px = px + this.itemWidth;		
		}
		
        var py = coords.t + this.bgHeight / 2;
        return {
            x: px,
            y: py
        };
    },
    
	/**
	 * get the middle points of a link to form the curve
	 * @param {Object} start The coordinate of the start position a link
	 * @param {Object} end The coordinate of the end position a link
	 */
    _getMiddlePoints: function(start, end){
		//compute the x and y coordinate of the middle positions
        var mx = (start.x + end.x) / 2;
		//compute the y coordinate of the first and second middle positions
        var my1 = start.y;
        var my2 = end.y;
        
        return [{
            x: mx,
            y: my1
        }, {
            x: mx,
            y: my2
        }];
    },
    
	 
	/**
	 * get the points of the arrow on a link
	 * @param {Object} end The coordinate of the end position a link
	 */
    _getArrowPoint: function(end){
        return {
            x: end.x,
            y: (end.y - this.arrowHeight/2)
        };
    },
	
	/**
	 * get the points of the back arrow on a link
	 * @param {Object} end The coordinate of the end position a link
	 */
    _getBackArrowPoint: function(node){
		//compute the x and y coordinate of the start posion 
		var startPoint = this._getStartPoint(node);
        return {
            x: startPoint.x - 2,
            y: startPoint.y - this.arrowHeight/2
        };
    },
	
    /**
	 * get the number of a size like "10px"
	 * @param {String} v The size in "10px" format
	 */
    _getPixel: function(v){
        return parseInt(v.substring(0, v.indexOf('p')),10);
    },
    
	/**
	 * compute the canvas dom node width
	 */
    getCanvasWidth: function(){
		var width = this.wiringModel.size.x * this.gridWidth - 80;
		if (width < this.minCanvasWidth) {
			width = this.minCanvasWidth;
		}
        return width;
    },
    
	/**
	 * compute the Dialog(Customized Dialog in Mashups) width
	 */
    getMMDialogWidth: function(){
        var width = (this.getCanvasWidth() + 2*(this.dialogSideBarWidth+1) + 2*this.canvasMargin);
        return (width + "px");
    },
	
	/**
	 * compute the canvas dom node height
	 */
    getCanvasHeight: function(){
		var height = this.wiringModel.size.y * this.gridHeight + 10;
		if (height < this.minCanvasHeight) {
			height = this.minCanvasHeight;
		}
        return height;
    },
	
	/**
	 * compute the Dialog container height
	 */
	_getDialogContainerHeight: function(){
		var height = this.getCanvasHeight();
		if (height > this.maxDialogHeight) {
			height = this.maxDialogHeight;
		}
		return height;
    },
    
	/**
	 * compute the Dialog(Customized Dialog in Mashups) height
	 */
	getMMDialogHeight: function(){
        var height = this._getDialogContainerHeight() + this.dialogTopAndBottom;
		return (height + "px");
    },
	
	/**
	 * compute the svg surface height
	 */
	_getSurfaceHeight: function(){
        return (this.getCanvasHeight() - 4);
    },
	
	/**
	 * add a wiring item dom node on wiring canvas
	 */
    _setWidgetPositionAndAdd: function(widget, left, top){
        widget.style.top = top;
		// #11717 No need to hack on IE6 from 2.0
//		if (dojo.isIE === 6 && builderConfig.isBidi) {
//			widget.style.left = (parseInt(left) - this.getCanvasWidth())+"px";
//		}
//		else {
			widget.style.left = left;
//		}
        this.graphContainer.appendChild(widget);
    },
    
	/**
	 * destroy all the wiring items and dialog
	 */
    destroy: function(){
		for (var i = 0, length = this.itemList.length; i < length; i++) {
			this.itemList[i].itemWidget.destroy();
		}
		this.inherited(arguments);
		this.wiringDialog.destroy();
	}
});




}
