if(!dojo._hasResource["com.ibm.mm.builder.widget.ShadowMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ShadowMenu"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.ShadowMenu");

dojo.require("dijit.Menu");
dojo.require("dojox.fx.Shadow");
/**
 * summary: cusomize the dijit.Menu with shadow
 */	
dojo.declare("com.ibm.mm.builder.widget.ShadowMenu", [dijit.Menu], {
	
	offset_x: 0,
	offset_y: 0,
	leftClickToOpen: true,
	openPosition:"BL",
	disable_shadow: false,
	
	postCreate: function(){
		this.inherited(arguments);
		if (!this.isLeftToRight()) { this.offset_x = -this.offset_x; }
		if (dojo.isIE === 6) { return; }
		this._connects.push([dojo.connect(window, "resize", this, function(){
			if (this.shadow) {
				this.shadow.setDisabled(true);
			}
			dijit.popup.close(this);
		})]);
		 //bug: resolve the problem that the style of menu can't adjust when user change the page theme
	    dojo.addClass(this.domNode,"lotusActionMenu");
	},
	
	/*
	 * override this method to fix dojo issue and builder bug 8934
	 */
	onItemHover: function(item){
		if (this.popupFocusTimer) {
			clearTimeout(this.popupFocusTimer);
		}
		this.inherited(arguments);
	},

	/*
	 * Override _openMyself method to change the menu display position.
	 * 
	 * offset_x and offset_y are used to adjust the position 
	 * according to the target node.
	 */
	_openMyself: function(/*Event*/ e, /*DomNode?*/ node, /*DomNode?*/ iframe){
		if(this.leftClickToOpen&&e.button>0){
			return;
		}
		//TODO fix ie refresh issue..
		try {
			dojo.stopEvent(e);
		} catch (err) {}

		//---change the default open position begin
		var tnode = e.target;
		if(this.targetNodeIds && this.targetNodeIds.length == 1){
			tnode = this.targetNodeIds[0];
		}
		var coords = dojo.coords(tnode, true);
		var cbox = dojo.contentBox(tnode);
		
		var xPack = 0;
		if(this.openPosition.charAt(1) == "R"){
			xPack = this.isLeftToRight() ? cbox.w : -cbox.w;
		}
		
		var x = coords.x + xPack + (this.offset_x||0) + (this.isLeftToRight() ? 0 : cbox.w);
		var y = coords.y + (this.openPosition.charAt(0) == "B" ? cbox.h : 0) + (this.offset_y||0);
		//---change the default open position end

		var self=this;
		var savedFocus = null; //hot fix for opera on spacemanager
		try{savedFocus = dijit.getFocus(this);}catch(error){}
		this.closeAndRestoreFocus = function(){
			// user has clicked on a menu or popup
			if (self.refocus && savedFocus) {
				dijit.focus(savedFocus);
			}
			dijit.popup.close(self);
		};
		
		this._prepareData();
		
		//no need to open menu without menu item 
		if (this.getChildren().length === 0) { return; }
		
		dijit.popup.open({
			popup: this,
			x: x,
			y: y,
			onExecute: this.closeAndRestoreFocus,
			onCancel: this.closeAndRestoreFocus,
			orient: this.isLeftToRight() ? 'L' : 'R'
		});
		this.focus();
		
		this._onBlur = function(){
			this.inherited('_onBlur', arguments);
			dijit.popup.close(this);
		};
	},
	
	_prepareData: function(){
		if (!this._isMenuCreated && !this._isMenuCreating) {
			this._isMenuCreating = true;
			this.prepareData();
			this._isMenuCreated  = true;
			this._isMenuCreating  = false;
		}
	},
	prepareData: function(){},
	
	_openPopup: function(){
		if(this.focusedChild.popup._prepareData){ this.focusedChild.popup._prepareData(); }
		
		if (this.focusedChild.popup.getChildren().length === 0) { return; }
		
		this._orient = this.isLeftToRight() ? {'TR': 'TL', 'TL': 'TR'} : {'TL': 'TR', 'TR': 'TL'};
		
		this.inherited(arguments);
	},
	
    onOpen: function(){
		this.inherited(arguments);
		if(this.disable_shadow){ return; }
		//if domnode is too small, no necessary to create shadow
		var p = dojo.marginBox(this.domNode);
		if(p.w < 1 && p.h < 1){return;}
		
		this.shadow = this.shadow || new com.ibm.mm.builder.widget.Shadow({
			node: this.domNode
		});
		
		this.resizeShadow();
	},
	
	resizeShadow:function(){
		var s = this.shadow;
		setTimeout(function(){
			if (s) {
				s.resize();
				s.setDisabled(false);
			}
		}, 50);
	},
	
	onClose: function(){
		//fix dojo1.3.2 issue: dojo do not remove the hovered item style by default
		dojo.forEach(this.containerNode.childNodes,function(item){
			dojo.removeClass(item,"dijitMenuItemHover");
			dojo.removeClass(item,"dijitMenuItemSelected");
		});
		this.inherited(arguments);
		if(this.shadow){
			this.shadow.setDisabled(true);
		}
	},
	
	destroy: function(){
		if(this.shadow){
			this.shadow.destroy();
			this.shadow = null;
		}
		//set the closure to null to avoid memory leak
		this._onBlur = null;
		this.closeAndRestoreFocus = null;
		//close menu to avoid memory leak on IE
		try {
			dijit.popup.close(this);
		} catch (e) {}//context menu of widget already destroy it, cannot close it.
		this.inherited(arguments);
	}
});
/**
 * summary: Adds a drop-shadow (right and bottom side if LTR, left and bottom if RTL) to a node.
 */
dojo.declare("com.ibm.mm.builder.widget.Shadow", dojox.fx.Shadow, {
	
	shadowPng: dojo.moduleUrl("com.ibm.mm.builder.widget", "resources/shadow"),
	
	//shadowThickness: Integer
	//How wide (in px) to make the shadow
	shadowThickness: 5,

	//shadowOffset: Integer
	//How deep to make the shadow appear to be
	shadowOffset: 0,
	
	//shadowOffset_x: Integer
	//How deep to make the shadow appear to be in x direction
	shadowOffset_x: 5,

	postCreate: function(){
		this.inherited(arguments);
		this.node.style.position = "relative";
		//create a fake node to represent the original node
		this.realNode = this.node;
		
		this.node = this._getFakeNode(this.realNode);
		
		this.pieces={};
		var x0 = this.shadowOffset_x;
		var x1 = -1 * this.shadowThickness + this.shadowOffset_x;
		var y0 = this.shadowOffset;
		var y1 = this.shadowOffset + this.shadowThickness;
		
		if(this.isLeftToRight()){
			this._makePiece("tr", "top", y0, "left", 0);
			this._makePiece("r", "top", y1, "left", 0, "scale");
			this._makePiece("bl", "top", 0, "left", x1);
			this._makePiece("b", "top", 0, "left", x0, "scale");
			this._makePiece("br", "top", 0, "left", 0);
		}else{
			x1 = -1 * this.shadowThickness;
			this._makePiece("tl", "top", y0, "left", x1);
			this._makePiece("l", "top", y1, "left", x1, "scale");
			this._makePiece("bl", "top", 0, "left", x1);
			this._makePiece("b", "top", 0, "left", 0, "scale");
			this._makePiece("br", "top", 0, "right", 0);
		}
		
		this.nodeList = dojo.query(".shadowPiece",this.node);
		//Set alt attribute for accessibility support and make sure all shadow can show over other menu
		dojo.forEach(this.nodeList, 'dojo.attr(item,"alt","");item.style.zIndex=1001;');
		
		//it seems menu will resize the created shadow, so commnet it to avoid invoke twice.
		//this.resize();
	},

	_getFakeNode: function(node){
		var coords = dojo.coords(node, true);
		
		var shadowDiv = dojo.query(dojo.create("div", null, dojo.body()))
			.addClass("mashupsShadowNode")
			.style({
				position: "absolute",
				left: coords.x + "px",
				top: coords.y + "px",
				zIndex: 998
			})[0];
		
		dojo.query(dojo.create("iframe", {frameborder: 0}, shadowDiv))
			.addClass("shadowedNodePlaceHolder").addClass("shadowPiece")
			.style({heith: "0px", width: "0px"});
		
		this._resizeFakeNode(shadowDiv);
		return shadowDiv;
	},
	
	setDisabled: function(/* Boolean */disabled){
		this.inherited(arguments);
		if (this.node) {
			this.node.style.visibility = disabled ? "hidden" : "visible";
		}
	},
	
	resize: function(args){
		this._resizeFakeNode();
		var x, y;
		if(args){ 
			x = args.x; y = args.y;
		}else{
			var co = dojo.marginBox(this.realNode);
			x = co.w; y = co.h;
		}
		var sideWidth = Math.max(x - this.shadowOffset_x, 0);
		var sideHeight = Math.max(y - (this.shadowOffset + this.shadowThickness), 0);
		y = Math.max(y, 1);
		x = Math.max(x, 1);
		
		if (this.isLeftToRight()) {
			dojo.marginBox(this.pieces.r, {h:sideHeight, l:x});
			dojo.marginBox(this.pieces.tr, {l:x});
			dojo.marginBox(this.pieces.br, {l:x});
		} else {
			dojo.marginBox(this.pieces.l, {h:sideHeight});
		}
		dojo.marginBox(this.pieces.b, {w: sideWidth, t:y});
		dojo.marginBox(this.pieces.bl, {t:y});
		dojo.marginBox(this.pieces.br, {t:y});
	},
	
	_resizeFakeNode: function(node){
		var fakeNode = node || this.node;
		var coords = dojo.coords(this.realNode, true);
		
		var pl = dojo.query(".shadowedNodePlaceHolder", fakeNode)[0];
		if(pl) { dojo.marginBox(pl, { w: coords.w, h: coords.h }); }
		if(fakeNode) { dojo.marginBox(fakeNode, {l: coords.x, t: coords.y}); }
	},
	
	uninitialize: function(){
		if(this.node){
			dojo.destroy(this.node);
			this.node = null;
		}
		this.inherited(arguments);
	}
});

}
