if(!dojo._hasResource["com.ibm.mm.builder.widget.WidgetMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.WidgetMenu"] = true;
/* Copyright IBM Corp. 2009, 2010  All Rights Reserved.                    */
/**
 * @author Marshall (shiwcsdl@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.WidgetMenu");

dojo.require("com.ibm.mm.builder.widget.MumMenu");
dojo.require("com.ibm.mm.builder.SkinHelper");

/**
 * This class is used to create menu, manage the action of menu item
 */
dojo.declare("com.ibm.mm.builder.widget.WidgetMenu", null, {

	iwidgetId: "",
	
	targetNode: null,
	
	inNva: false,
	
	pMenu: null,
	
	editPane: null,
	
	editorDiv: null,
	
	cws: com.ibm.mm.builder.coreWidgetsStrings,
	
	supportedModeString : {
		'print': com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MODE_PRINT,
		'help': com.ibm.mm.builder.coreWidgetsStrings.I_CONTEXT_MENU_MODE_HELP
	},
	
	// temp fix for old widget spec
	oldWidgetConfigId:"",
	oldWidgetConfigParentNode:null,
	// end temp fix
	
    constructor: function(params){
		this.needResizeMoveMenuItems = true;
		
		dojo.mixin(this, params);
        this.LOGGER = com.ibm.mashups.enabler.logging.Logger.getLogger("com.ibm.mm.builder.widget.WidgetMenu");
        this.eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        this.widgetModes = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetSupportedModes(this.iwidgetId);
        this.cleanDomDialogHandle = dojo.subscribe(com.ibm.mm.builder.eventTopics.Page_ContentChanged, this, "cleanDomDialog");
    	// subscribe topic which need to support v1.1 widget 
		dojo.subscribe(com.ibm.mm.builder.Topics.Widget_ConfigurationFinished, this, "closeEditDialog");
    },
	
	hasEditMode:function(){
		return this.isWidgetLoaded() && dojo.indexOf(this.widgetModes, "edit") >= 0;
	},
	
	isWidgetLoaded: function(){
		var widgetModel = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(this.iwidgetId);
		return widgetModel && widgetModel.loaded;
	},
	
	createOtherModesItem: function(){
		var modePopup = null; 
		var widgetMenu = this;
		dojo.forEach(this.widgetModes, function(mode){
            if (mode != "view" && mode != "edit") {
				modePopup = modePopup || new com.ibm.mm.builder.widget.MumMenu({
					id: this.targetNode.id + "_mode",
					parentMenu:	this.pMenu
				});
                modePopup.addChild(new com.ibm.mm.builder.widget.MumMenuItem({
                    label: mode.charAt(0).toUpperCase() + mode.substring(1),
                    userMode: mode,
                    onClick: function(){ widgetMenu.showModePane(this.userMode); }
                }));
            }
		}, this);
		if(modePopup) {
			this.pMenu.addChild(new com.ibm.mm.builder.widget.MumPopupMenuItem({
				label: this.cws.I_CONTEXT_MENU_MODE, 
				popup: modePopup,
				disabled: !this.isWidgetLoaded()
			}));
		}
	},
	
	createSkinItem: function(){
		
		var widgetMenu = this;
        var skinPopup = new com.ibm.mm.builder.widget.MumMenu({
            id: this.targetNode.id + "_skin",
            parentMenu: this.pMenu
        });
        
		var iwidgetId = this.iwidgetId;
		var widgetSkin = dojo.byId(this.iwidgetId).getAttribute("skin");
        
		var lc = com.ibm.mashups.enabler.context.Factory.getLocalizedContext();
       	dojo.forEach(com.ibm.mm.builder.utils.skinUtil.getAllSkins(), function(skin){
        	if (!skin.getMetaData("com.ibm.mashups.builder.skin.nva")) {
                var skinTitle = skin.getTitle(ibmConfig["default.locale"] != dojo.locale ? 
					lc.getLocale(skin) : dojo.locale);
                var skinMenuItem = new com.ibm.mm.builder.widget.MumMenuItem({
                    label: skinTitle,
                    skinID: skin.getID(),
                    iconClass: skin.getID() == widgetSkin ? "menuIconClass" : "",
                    onClick: function(){ 
						widgetMenu.eventService.broadcastEvent("com.ibm.mashups.builder.changeSkin", {
							id: iwidgetId, skin: this.skinID });
					}
                });
				
				//for a11y
				if (widgetSkin == skin.getID() && !(dojo.isIE === 8 && builderConfig.isBidi)) {
					var dijitMenuLabelA11y = dojo.doc.createElement("span");
					dojo.addClass(dijitMenuLabelA11y,"access");
					dijitMenuLabelA11y.innerHTML = "is selected";
					skinMenuItem.containerNode.appendChild(dijitMenuLabelA11y);		
				}
				skinPopup.addChild(skinMenuItem);
            }
		}, this);
		
		this.pMenu.addChild(new com.ibm.mm.builder.widget.MumPopupMenuItem({
			label: this.cws.I_CONTEXT_MENU_SKIN, 
			popup: skinPopup,
			disabled: !this.isWidgetLoaded()
		}));		
    },
	
	createDiaplayItem: function(inNva){
		return new com.ibm.mm.builder.widget.MumMenuItem({
            label: inNva ? this.cws.I_CONTEXT_MENU_DISPLAY : this.cws.I_CONTEXT_MENU_HIDE,
			iconClass : inNva ? "contextMenuIconDisplay" : "contextMenuIconHide",
			disabled: !this.isWidgetLoaded(),
            onClick: dojo.hitch(this, function(){
                this.eventService.broadcastEvent(
					inNva ? "com.ibm.mashups.builder.displayWidget" : "com.ibm.mashups.builder.hideWidget", 
					this.iwidgetId);
            })
        });
	},
	
	createMenu: function(){
        this.pMenu = new com.ibm.mm.builder.widget.MumMenu({
            targetNodeIds: [this.targetNode],
            id: this.targetNode.id + "_menu"
        });
		
		var mycontextmenu = com.ibm.mashups.builder.model.Factory.getContextMenuModel();
		var widgetMenus = mycontextmenu.getContextMenu("ContextMenu.widgetSkin",this.iwidgetId,null,{context:this});
		
		//move to new menu, but lack of support for sub menu
		for (var i = 0; i < widgetMenus.length; ++i) {
			
			if(widgetMenus[i].isSeparator){
				if (this.needResizeMoveMenuItems){
					this.pMenu.addChild(new com.ibm.mm.builder.widget.MumMenuSeparator());				
				}else{
					if (widgetMenus[i].id != "resizeMenuSeparator") {
						this.pMenu.addChild(new com.ibm.mm.builder.widget.MumMenuSeparator());	
					}
				}
				continue;
			}
			
			if (!this.needResizeMoveMenuItems){
				if ((widgetMenus[i].id === "resize") || (widgetMenus[i].id === "move")){
					continue;
				}
			}
			var itemId = widgetMenus[i].id ? widgetMenus[i].id : "";
			switch(itemId) {
				case "supportModes":
						this.createOtherModesItem();	// Other mode support
					break;
				case "skins":
						if(!this.inNva) {
							this.createSkinItem();
						}
					break;
				case "hideOrShow":
						this.pMenu.addChild(this.createDiaplayItem(this.inNva));
					break;
				default:
						var mitem = new com.ibm.mm.builder.widget.MumMenuItem({
							label: 		widgetMenus[i].title,
							iconClass: 	widgetMenus[i].iconClass,
							disabled: 	!widgetMenus[i].enabled,
							onClick: 	widgetMenus[i].actionCallBackFunction
						});	
						this.pMenu.addChild(mitem);
					break;
			}
		}
        this.pMenu._pubMenuEvent = dojo.hitch(this, this.hideMenu);
        this.pMenu.startup();	
	},
	
	open: function(evt){
		if(this.pMenu) {
			this.pMenu.destroyRecursive();
			delete this.pMenu;
		}
		if (!this.pMenu) {
			this.createMenu();
		}
		this.pMenu._openMyself(evt);
	},
		
    showModePane: function(mode){
        mode = mode.toLowerCase();
        var widgetTitle = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.iwidgetId);
        //mode Title, we support "help" and "print" currently
        var modeStr = this.supportedModeString[mode.toLowerCase()]; 
        var modeTitle = modeStr || mode.charAt(0).toUpperCase() + mode.substring(1);
        widgetMenu = this;
        this.otherModePane = new com.ibm.mm.builder.widget.GeneralWidgetModeDialog({
            id: this.iwidgetId + "_" + mode,
            title: dojo.string.substitute(this.cws.I_SYSTEM_MODE_TITLE, [modeTitle, widgetTitle]),
            type: mode,
			nodeWidth: "600px",
			nodeHeight: "400px",			
            needModeSwitch: true,
            belongId: this.iwidgetId,
            containerBackgroundColor: "white",
            closeCallback: function(){
                this.destroyRecursive();
            }
        });
        com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.iwidgetId, "onModeChanged", {
            newMode: mode,
            rootElementId: this.otherModePane.containerNode
        });
        this.otherModePane.show();
    },

	showEditPane:function(){
		// temp fix for old widget spec
		this.oldWidgetConfigId = "";
		this.oldWidgetConfigParentNode = null;
		// end temp fix
		
		var widgetSpan = dojo.byId(this.iwidgetId);
		var configNodeId = "";
		
        var items = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(com.ibm.mm.builder.constant.mmItem, widgetSpan);
        dojo.forEach(items, function(item){
        	var str = com.ibm.mm.builder.utils.iWidgetSpecUtil.getKeyFromHref(item);
            if (str == com.ibm.mm.builder.constant.configPannelNode) {
				configNodeId = "_" + this.iwidgetId + "_" + item.innerHTML.replace(/\n/g, "");
			}
        });
		
		if (configNodeId){
			// temp fix for old widget spec
			this.oldWidgetConfigId = configNodeId;
			this.oldWidgetConfigParentNode = dojo.byId(configNodeId).parentNode;
			// end temp fix
			
			var editnode = dojo.byId(configNodeId);
			editnode.style.display = "";
			this.editorDiv.appendChild(editnode);
		}	
		var _title = com.ibm.mm.builder.utils.iwidgetUtil.getWidgetInstanceTitle(this.iwidgetId);
		if (!com.ibm.mm.builder.editPane) {
			com.ibm.mm.builder.editPane = new com.ibm.mm.builder.widget.WidgetEditDialog({
				id: this.iwidgetId + "_edit",
				title: dojo.string.substitute(this.cws.I_SYSTEM_CONF_TITLE, [_title]),
				type: "config",
				nodeWidth: dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "600px" : null,
				nodeHeight: dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "400px" : null,
				needModeSwitch: true,
				modelDialog: true,
				belongId: this.iwidgetId,
				containerBackgroundColor: "white"
			});
		} else { // the edit dialog exists
			com.ibm.mm.builder.editPane.setTitle(dojo.string.substitute(this.cws.I_SYSTEM_CONF_TITLE, [_title]));
			com.ibm.mm.builder.editPane.id = this.iwidgetId + "_edit";
			com.ibm.mm.builder.editPane.belongId = this.iwidgetId;
			com.ibm.mm.builder.editPane.nodeWidth = dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "600px" : null;
			com.ibm.mm.builder.editPane.nodeHeight = dojo.byId(this.iwidgetId).getAttribute("sandbox") === "true" ? "400px" : null;
			com.ibm.mm.builder.editPane.containerNode.innerHTML = "";
			com.ibm.mm.builder.editPane.dynaInitialized = false;
			com.ibm.mm.builder.editPane.containerNode.style.display = "";
		}
		this._fillInEditModeContent(configNodeId);
		com.ibm.mm.builder.editPane.show();
	},
	
	_fillInEditModeContent:function(configNodeId){
		if (!configNodeId) {
            com.ibm.mashups.services.ServiceManager.getService("eventService").fireEvent(this.iwidgetId, "onModeChanged", {
                newMode: 'edit',
				rootElementId: com.ibm.mm.builder.editPane.containerNode
            });
        }
		// temp fix for old widget spec
		if (this.oldWidgetConfigId != ""){
			var _oldWidgetConfigId = this.oldWidgetConfigId;
			var _oldWidgetConfigParentNode = this.oldWidgetConfigParentNode;
			com.ibm.mm.builder.editPane.oldWidgetSpecHitch = function(){
				if ((_oldWidgetConfigId!="") && (_oldWidgetConfigParentNode)){
					dojo.byId(_oldWidgetConfigId).style.display = "none";
					_oldWidgetConfigParentNode.appendChild(dojo.byId(_oldWidgetConfigId));
				}
			};
		}
		// end temp fix
	},
	
	hideMenu:function(){
		dojo.unsubscribe(this.cleanDomDialogHandle);
		dojo.unsubscribe(this.editActionHandle);
		if (this.pMenu) {
			this.pMenu.destroyRecursive();
		}
		if (this.modePopup) {
			this.modePopup.destroyRecursive();
		}
		if (this.skinPopup) {
			this.skinPopup.destroyRecursive();
		}
		var editBar = dijit.byId(this.iwidgetId + com.ibm.mm.builder.constant.editbarDragHandler);
		if (editBar) {
			editBar.hide();
		}
		// fix for defect 11622
		var widgetSpan = dojo.byId(this.iwidgetId);
		if (widgetSpan){
			if (widgetSpan.getAttribute("visible") === "false"){
				// widget in NVA, the widget skin need to switched to view mode
				com.ibm.mm.builder.skinHelper.hideNVASkinEditMode(this.iwidgetId+"_menu", this.iwidgetId+"_icon", this.iwidgetId+"_name", this.iwidgetId+"_upper");
			}			
		}
		this.pMenu = null;
		this.modePopup = null;
		this.skinPopup = null;
	},
	
	cleanDomDialog: function(){
		this.destroyElementsFromBodyByClass("dijitDialog");
		this.destroyElementsFromBodyByClass("dijitDialogUnderlayWrapper");		
	},
	
	// only for v1.1 widgets
	closeEditDialog: function(widgetId){
		this.eventService.fireEvent(widgetId, "onModeChanged", {newMode:'view'});
	},
	
	destroyElementsFromBodyByClass:function(clzName){
		var elements = com.ibm.mm.builder.utils.htmlUtil.getChildrenbyClass(clzName, dojo.body());
		for (var j=0; elements && j<elements.length;j++){
			if (clzName === "dijitDialog" && elements[j].getAttribute("widgetid") === "pageSourceContainer") {
				continue;
			}	
			dojo.destroy(elements[j]);	
		}
	},
	
	destroy:function(){
		if (this.pMenu) {
			this.pMenu.destroyRecursive();
		}
		delete this.pMenu;
	}
});

com.ibm.mm.builder.editPane = null;

}
