// dojo.provide("com.ibm.mm.builder.systemwidget.TemplateLayout");

dojo.declare("com.ibm.mm.builder.systemwidget.TemplateLayout", null,{
    
    WID:null,
    targetDiv:null,  
    pageId:null, 
    navStateModel:null,
    pageAccessor:null,
    navModel:null,
    currentPageID:null,
    currentPage:null,
    serverRuntimeContent:null,
    previousWidgetIdsToUnload:null,
    hiddenContainerOpen:false,
    layoutParser:com.ibm.pb.layout.LayoutParser,
    
    onLoad: function(){
        this.WID = "_" + this.iContext.widgetId + "_";
        var attributes = this.iContext.getiWidgetAttributes();
        var targetDiv = attributes.getItemValue("targetDiv");
        this.targetDiv = dojo.byId(targetDiv);
        if (!this.targetDiv) {
          this.targetDiv = dojo.byId(this.WID + "templateLayoutDiv");
        }

        var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
        eventService.subscribeEvent("com.ibm.mm.builder.systemwidget.TemplateLayout.UnloadContinue", this, "_unloadContinue");
        
        this.navStateModel = com.ibm.mashups.enabler.model.state.NavigationStateModelFactory.getNavigationStateModel();
        this.pageAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getPageAccessor(this.navStateModel);
        this.navModel = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel();
        this.configService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.ConfigService.SERVICE_NAME);
        var runtimeModel = com.ibm.mashups.builder.model.Factory.getRuntimeModel();
		
        if (this.pageAccessor.getPageID() !== ibmPortalConfig.currentPageOID) {
            // we need to set this for unloading, otherwise this lazy switch won't work
            var pageID;
            if ("-1" !== ibmPortalConfig.currentPageOID) { // -1 means the full page does not contain the content
                pageID = ibmPortalConfig.currentPageOID;
            }
            else {
                pageID = this.pageAccessor.getPageID();
            }
            this.currentPage = this.navModel.find(pageID).start();
			
            // if the theme in the bootstrap does not match the page, then we must do a full
            // page refresh
            if (ibmCfg.themeConfig.themeUniqueName !== this.currentPage.getThemeIdentifier().getID()) {
                // we need to set the cookie for the bootstrap to pick up the correct page id, otherwise we would refresh forever
                com.ibm.mm.builder.utils.navigationUtil.setPageIDCookie(pageID);
                // this is a special marker with which certain extensions can behavior differently. In this particular case
                // it allows to write an unload extension that can differentiate from a normal browser close vs a refresh caused by mashups
                window.__page_reload_marker = true;
                // navigational state has been updated earlier, simply refresh
                window.location.reload();
            }

            this.serverRuntimeContent = null;

            if ("-1" !== ibmPortalConfig.currentPageOID) { // -1 means the full page does not contain the content
                this.getCurrentPage(dojo.hitch(this, "refreshLayoutTimer"));
            }
            else {
                this.currentPageID = "-1";
                this.getCurrentPage(dojo.hitch(this, "refreshLayout"));
            }
        }
        else {
            this.getCurrentPage();
        }
    },

    refreshLayoutTimer: function() {
        setTimeout(dojo.hitch(this, function(){
            this.onLayoutRefresh();
        }), 50);
    },
    
    getCurrentPage: function(/*Function?*/cbk){
        var newPageID = this.pageAccessor.getPageID();
        if (newPageID == this.currentPageID) {
            return;
        }
        this.currentPageID = newPageID;
        this.currentPage = null;
        this.serverRuntimeContent = null;

        if (!this.currentPageID) {
            return null;
        }
        var deferred = this.navModel.find(this.currentPageID);
        deferred.setFinishedCallback(dojo.hitch(this, "getCurrentPageContinue"), {callback: cbk});
        deferred.start(false);
    },

    getCurrentPageContinue: function(currentPage, status, params){
        this.currentPage = currentPage;
        if(params && params.callback) {
            params.callback();
        }
    },
    
    getServerRuntimeContent: function() {
        if(this.currentPage && this.currentPage.getNavigationElementType() != com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL) {
            this.serverRuntimeContent = this.currentPage.getServerRuntimeContent();
        }
        else {
            this.serverRuntimeContent = null;
        }
        return this.serverRuntimeContent;
    },
    
    primeServerRuntimeContent: function(value) {
        if(this.currentPage 
           && this.currentPage.getNavigationElementType() != com.ibm.mashups.enabler.navigation.Constants.NAVIGATION_LABEL
           && com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "view") {
        	
//			activating priming here seems to be too late, let's do this in the RenderController        	
//        	console.info("activating Optimus Prime!");
//          this.currentPage.primeServerRuntimeContent(value);
        }
    },
    
    onview:function(){

    },
    
    onUnload: function(){

    },

    onLayoutRefresh: function(iEvent){
        if (!this.currentPage) {
            return;
        }

        if (iEvent && iEvent.payload && (typeof iEvent.payload == "string") && (iEvent.payload.length > 0)) {
			var node =this.layoutParser.findById(iEvent.payload);
            // unload previous stored widgets - only the differences
            var unloadArray = this.getContainedWidgetsInLayout(node);
            unloadArray = this.addMissingWidgets(unloadArray, this.previousWidgetIdsToUnload);
            //this.unloadWidgetIds(this.transform(unloadArray));
            this.reloadWidgetIds(this.transform(unloadArray), iEvent.payload);
            // container/control id - refresh one container/control
            this.refreshContainerOrControlContinue(iEvent.payload);
        } else {
            // no container id - unload entire layout
            var unloadArray = this.getContainedWidgetsInLayout();
            unloadArray = this.addMissingWidgets(unloadArray, this.previousWidgetIdsToUnload);
            this.unloadWidgetIds(this.transform(unloadArray));
            // no container id - refresh entire layout
            this.refreshLayout();
        }
        // init for next call
        this.previousWidgetIdsToUnload = this.getContainedWidgetsInLayout();
    },
    // missing widgets are widgets that have been deleted from the layout or
    // that have been converted into managed once and hence the client ID is not available any further
    addMissingWidgets: function(unloadArray, previousWidgetIdsToUnload)
    {
        if (!previousWidgetIdsToUnload) {
            return unloadArray;
        }
        var i;
        for (i=0; i<previousWidgetIdsToUnload.length; i++) {
            var element = previousWidgetIdsToUnload[i];
            var controlID = element.controlID;
            var id = element.value;
            if (id.indexOf("widgetActionsMenu_") === 0) {
                id = id.substring(18);
            }
            var node = this.layoutParser.findById(controlID);
            if (node === null) {
                unloadArray.push(element);
            }
        }
        return unloadArray;
    },
    getContainedWidgetsInLayout: function(node) {
		var controls =this.layoutParser.findControls(node||this.layoutParser.getRootNode());
		if(!controls){
			controls=[];
		}
		if(!!node){
			var className = dojo.attr(node,"class");
			if(!!className &&className.indexOf("component-control")>=0){//node is a layout cotnrol
				controls.push(node);
			}
		} 
		var controlObjects=[];
		dojo.forEach(controls,function(control){
			 var cID = this.layoutParser.extractID(control);
             controlObjects.push({"controlID" : cID, "value" : cID});
             controlObjects.push({"controlID" : cID, "value" : "widgetActionsMenu_" + cID});
		},this);
		return controlObjects;
    },

    unloadPreviousAndRefreshLayout: function(){
        // now we load the widgetIds of the controls that are currently in the layout model
        this.previousWidgetIdsToUnload = this.getContainedWidgetsInLayout();
        this.refreshLayout();
    },

    refreshLayout: function(){
		this.layoutParser.clearCachedContainers();
        var serverRuntimeContent = this.getServerRuntimeContent();
        if (!serverRuntimeContent) {
            var defaultLabelContent = this.configService.getValue("labelDefaultRuntimeContent");
            if(defaultLabelContent) {
                if(dojo.isFunction(defaultLabelContent)) {
                    defaultLabelContent = defaultLabelContent(this.currentPageID);
                }
            }
            this.preRenderProcessLayout(defaultLabelContent || "");
        }
        else {
            var deferred = serverRuntimeContent.getServerRuntimeMarkup(null); 
            deferred.setFinishedCallback(dojo.hitch(this, "preRenderProcessLayout"));
            deferred.start(false);      
        }
    },
            
    preRenderProcessLayout: function(markup){
        // null id means entire layout; non-null id means individual container or control
        // using null id here for entire layout
        com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.preRenderProcess", {"id":null, "markup":markup}, "any", this.iContext.widgetId);
        // pre-render processing is handled by the RenderController and then a
        // com.ibm.mashups.builder.preRenderComplete event comes back after pre-render processing
        // is complete, which then continues at this.onPreRenderComplete
    },
    
    refreshContainerOrControlContinue: function(cID) {
		//this method will only invoked when refresh a part of layout. E.g. rename a widget 
		var layoutModel = this.currentPage ? this.navModel.getLayoutModel(this.currentPage) : null;
		if(!!layoutModel){
			var containerOrControl = layoutModel.find(cID).start();
			var deferred = containerOrControl.getRuntimeContent().getRuntimeMarkup();
            deferred.setFinishedCallback(dojo.hitch(this, "preRenderProcessContainer"), cID);
            deferred.start(false);      
		}
    },  
    preRenderProcessContainer: function(markup, status, id){
        // null id means entire layout; non-null id means individual container or control
        // using id here for individual container or control
        com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.preRenderProcess", {"id":id, "markup":markup}, "any", this.iContext.widgetId);
        // pre-render processing is handled by the RenderController and then a
        // com.ibm.mashups.builder.preRenderComplete event comes back after pre-render processing
        // is complete, which then continues at this.onPreRenderComplete
    },
    
    onPreRenderComplete: function(iEvent){
        if (iEvent && iEvent.payload) {
            var payload = iEvent.payload;
            if (payload.id && typeof payload.id == "string") {
                // var div = dojo.byId(payload.id); // TEMP
                var div = dojo.query(".id-" + payload.id)[0];
                if (div && payload.markupDivId && typeof payload.markupDivId == "string") {
                    this.refreshContainerContinue(payload.markupDivId, null, div, payload.id);
                }
            }
            else {
                if (typeof payload == "string") {
                    this.refreshLayoutContinue(payload, null);
                } else if (payload.markupDivId && typeof payload.markupDivId == "string") {
                    this.refreshLayoutContinue(payload.markupDivId, payload.fn);
                }
            }
        }
        if (this.hiddenContainerOpen){
            dojo.query(".hiddenWidgetsContainer").forEach(function(node, index, arr) {
                node.style.display = "block";
            });         
        }
		this._processContainerControls(this.targetDiv);       
    },

	_processContainerControls: function(node){
        var pid = com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getID();
		var widgetAccessor = null;
		
        var layoutAccessor = com.ibm.mashups.enabler.model.state.AccessorFactory.getLayoutAccessor(this.navStateModel, pid);
        var navstateTemplateUrl = layoutAccessor.getTemplateURL();
        
        // if there is no Navstate template URL 
        // or if it is different from the Instance template URL
        // then remove the layout and all the sizes of widgets on the page
        var removeLayoutAndWidgetSizes = true;
        if (navstateTemplateUrl) {
            // get the page instance layout template url
            var navNode = com.ibm.mashups.enabler.navigation.Factory.getNavigationModel().find(pid).start(true);
            var content = navNode.getContent().start(true);
            var instanceTemplateUrl = content.getMetaData("com.ibm.portal.layout.template.ref");
            removeLayoutAndWidgetSizes = (navstateTemplateUrl != instanceTemplateUrl);
        }
        if(removeLayoutAndWidgetSizes) {
            var pageWidgets = [];
            dojo.query(".component-control", this.layoutParser.getRootNode()).forEach(
                function(control){
                    // we can assume that window ID and control ID are always the same, even in live preview
                    var widgetId = this.layoutParser.extractID(control);
                    pageWidgets.push(widgetId);
                }, 
                this);
            
            layoutAccessor.removeAll(pageWidgets);
            this.navStateModel.commit().start();
            // nothing to override so might as well quit now
            return;
        }
        // NOTE:
        // If no widget size changes or layout changes have been made to this page
        // then the navstateTemplateUrl will be null and we will do the deletion
        // this seems pointless, but it is the only clean way I know to solve the problem
        // that BSpace may delete the lcparams for the page without deleting the widgets on the page
        // IF this turns out to be pointless AND EXPENSIVE
        // then there are two other options
        // 1) inside the if above, create the lcparams for the page with the template url
        // 2) keep the widget sizes around, and run the above code in the two places where
        //    we update the widget size and set the layout (WidgetResizer and RuntimeWidgetResize)
        //    and where we update column sizes (ContainerResizer)
        // -dosofsky, 07-apr-2011
    
        // gather window states of the controls
        dojo.forEach(
            this.layoutParser.findContainers(node),
            function(control){
                var cid = this.layoutParser.extractID(control);
                var containerAccessor = layoutAccessor.getContainerAccessor(cid);
                if(!!containerAccessor){
                    var size = containerAccessor.getSize();
                    if(!!size){
                        dojo.style(control,{width:size[containerAccessor.WIDTH]});
                    }
                }
            }, 
            this);
        
	},

    refreshLayoutContinue: function(markupDivId, fn){
        this.resetDND();
        if (typeof fn === 'function'){
            // we need to keep the API the same
            var markupNode = dojo.byId(markupDivId);
            var markup = markupNode.innerHTML;
            fn(this.targetDiv, markup, dojo.hitch(this, "updateLiveText"));
        } else {
            //replace div
            while (this.targetDiv.firstChild) {
                //this.targetDiv.removeChild(this.targetDiv.firstChild);
				dojo.destroy(this.targetDiv.firstChild);
            }
            var markupNode = dojo.byId(markupDivId);
            while (markupNode.firstChild) {
                this.targetDiv.appendChild(markupNode.firstChild);
            }
            this.primeServerRuntimeContent(this.targetDiv);
            this.updateLiveText(this.targetDiv, null);
        }
        this.initLayoutControl(this.targetDiv);
        this.initDND();
    },

    refreshContainerContinue: function(markupDivId, status, div, id) {
        this.resetDND();
        var markupNode = dojo.byId(markupDivId);
        var markup = markupNode.innerHTML;
        dojo.place(markup, div, "replace");
        this.primeServerRuntimeContent(this.targetDiv);
        var targetDiv = this.layoutParser.findById(id);
        this.updateLiveText(targetDiv, "control." + id);
        this.initDND();
    },
	
    initLayoutControl: function(container){
        var freeform = dojo.query(".ibmFreeform", container)[0];
        var dirty = false;
        if (freeform) {
            var containerId = this.layoutParser.extractID(freeform);
            var layoutheight = parseInt(dojo.style(freeform, "height"), 10);
            if (!layoutheight) 
                layoutheight = 700;
            var payload = [];
            dojo.query(".component-control", freeform).forEach(function(node, index, arr){
                var widgetId = this.layoutParser.extractID(node);
                var cssTextArray = node.style.cssText.split(";");
                var styleLength = cssTextArray.length;
                if (styleLength <= 1) {
                    payload.push({
                        "widgetId": widgetId,
                        "index": index
                    });
                    dirty = true;
                }
            }, this);
            if (payload.length > 0) {
                var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
                eventService.broadcastEvent("com.ibm.mashups.builder.initWidgets", {
                    "containerId": containerId,
                    "data": payload
                });
            }
        }
    },

    updateLiveText: function(targetDiv, id){
        // fetch all the windows on the page
        var windowArray = this.getContainedWidgetsInLayout();
        var map = {};
        dojo.forEach(windowArray,function(controlObject){
            map[controlObject.controlID] = controlObject.controlID;
        },this);
        var strategy = new com.ibm.mashups.enabler.strategy.WidgetWindowLoadAheadStrategy(map);
        var strategyService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.enabler.services.StrategyService.SERVICE_NAME);
        strategyService.setStrategy("com.ibm.mashups.enabler.widget.WidgetModel", strategy);
        
        dojo.publish("/com/ibm/mashups/livetext/livetextchanged", [targetDiv, true]);
        // null payload means entire layout; non-null payload is the id of the individual container or control that got refreshed
        // using null id here for entire layout
        com.ibm.mashups.services.ServiceManager.getService("eventService").broadcastEvent("com.ibm.mashups.builder.layoutRefreshed", id, "text", this.iContext.widgetId);
    },    

    resetDND: function(){
        ibmCfg.controllers.dnd.reset();
    },
    
    initDND: function(){
        if(com.ibm.mashups.builder.model.Factory.getRuntimeModel().getCurrentPage().getPageMode() == "edit"){
            ibmCfg.controllers.dnd.init();
        }
    },
    
    onPageSwitched: function(iEvent){
        this.pageId = iEvent.payload;
        this.hiddenContainerOpen = false;
        if (this.pageId == "com.ibm.mm.builder.embedPageFailErrMsg"){
            this.loadMsgToLayout(com.ibm.mm.builder.coreWidgetsMessages.E_EMBEDDING_PAGEACCESS_ERROR_0); 
            return;
        }
		this.previousWidgetIdsToUnload = this.getContainedWidgetsInLayout();
        if (this.previousWidgetIdsToUnload !== null) {
            this.unloadWidgetIds(this.transform(this.previousWidgetIdsToUnload));
        }
        if (!this.pageId) {
            this.loadMsgToLayout(com.ibm.mm.builder.coreWidgetsStrings.W_NO_PAGE_TO_SHOW);
            return;
        } else {
            this.getCurrentPage(dojo.hitch(this, "unloadPreviousAndRefreshLayout"));
        }
    },
    
    transform: function(unloadArray) {
        var ret = [];
        var i;
        for (i=0; i<unloadArray.length; i++) {
            var element = unloadArray[i];
            ret.push(element.value);
        }
        return ret;
    },
    unloadWidgetIds: function(widgetIdArray) {
        com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS, widgetIdArray);
    },
    reloadWidgetIds: function(arr, id) {
        var pl = {refreshId: id, unloadArray: arr};
        com.ibm.mashups.services.ServiceManager.getService("eventService").publishEvent(com.ibm.mashups.iwidget.Constants.UNLOAD_WIDGETS, pl);
    },  
    _unloadContinue: function(json) {
        var callback = json.callback;
        var control = json.control;
        if (dojo.isFunction(callback)) {
            // call callback
            dojo.partial(callback)(control);
        }
    },

   onViewHiddenWidgets: function(iEvent){

    	this.checkForHiddenTimelineWidget(); 

		dojo.query(".hiddenWidgetsContainer").forEach(function(node, index, arr) {
			node.style.display = "block";
		});
		this.hiddenContainerOpen = true;
    },
    
    onHideHiddenWidgets: function(iEvent){
        dojo.query(".hiddenWidgetsContainer").forEach(function(node, index, arr) {
            node.style.display = "none";
        });
        this.hiddenContainerOpen = false;
    },
    
  	onSkinLoaded: function(iEvent){
        var controlId = iEvent.payload.widgetId;
        var widgetId = controlId; // we can assume that window ID and control ID are always the same, even in live preview
    	var loadedHandler = null;
		var self = this;
    	var publishWidgetSize = function() {
    		var div = self.layoutParser.findById(controlId);
    		if (div) {
				var widgetBody = dojo.query(".lotusWidgetBody", div)[0];
    			if (widgetBody) {
    				var widgetBox = dojo.contentBox(widgetBody);
		            var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
		            var payload = {"newWidth": Math.max(0, widgetBox.w),"newHeight": Math.max(0, widgetBox.h)};
		     		eventService.publishEvent(com.ibm.mashups.iwidget.Constants.RESIZE_WIDGET + "." + widgetId, payload);
    			}
    		}
    		if (loadedHandler) {
    			eventService.unsubscribeEvent(loadedHandler, null);
   	    	}
    	};
    	var wm = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel().find(widgetId);
    	if (wm && wm.loaded) {
     		publishWidgetSize();
    	} else {
    		var eventService = com.ibm.mashups.services.ServiceManager.getService("eventService");
    	  	loadedHandler = eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + widgetId, null, publishWidgetSize);
        }
    },
	
    loadMsgToLayout:function(msg){
        this.targetDiv.innerHTML = this.getEmptyPageMessage(msg);
    },

    getEmptyPageMessage:function(msg){
        var empty_content = 
            "<div class='empty_div'>"+
                "<div class='empty_outer_div'>" +
                    "<div class='empty_inner_div'>" +
                    com.ibm.mm.builder.utils.htmlUtil.formatMessage(msg) +
                    "</div>" +
                "</div>"+
            "</div>";
        return empty_content;
    },
   
    loadNullToLayout:function(){
        this.targetDiv.innerHTML = "";
    },
	
    checkForHiddenTimelineWidget:function() {
    // 19627: If the hidden container contains a timeline widget then we need to publish a forceResize event in order to get the widget
    // to display when the hidden area is first shown.  The subscribe is in the timeline widget onLoad method.
		var timelineContainerNodes = dojo.query(".hiddenWidgetsContainer .timeline-container");
		if (timelineContainerNodes.length > 0) {
			var controlId = timelineContainerNodes[0].id;

			var timelineComponentControlClass = controlId.replace("_timeline", "");
			timelineComponentControlClass = ".id-" + timelineComponentControlClass.substring(1);
			var timelineComponentControls = dojo.query(".hiddenWidgetsContainer " + timelineComponentControlClass);

			var existingWidth = parseInt(dojo.style(timelineContainerNodes[0], "width"));
			if (!existingWidth || existingWidth < 1 ) {
			// get the component-control which will have a width
				if (timelineComponentControls.length > 0) {
					existingWidth = parseInt(dojo.style(timelineComponentControls[0], "width"));
				}
			}	

			if (existingWidth && existingWidth > 0) {
				dojo.publish("forceResize", [{
    				width: existingWidth, height: "200", controlId: controlId  
	 			}]);	 
			}
	  	}
    }	

});
